#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, re, cairo

fontface_h = 'Droid Sans Fallback'
fontface_z = 'MotoyaLMaru'
#fontface_z = 'MotoyaLCedar'

root0 = './src/'
root1 = './backup/'
root2 = './custom/'
root3 = './src/'
svgdir  = 'data/images/android/svg/'
svndir  = 'data/images/android/svg/.svn/'
workdir = 'data/images/android/work/'

def load(path):
	if not os.path.isfile(path): return None
	f = open(path, 'r')
	text = f.read()
	f.close()
	return text;

def save(path, text):
	if text is None or load(path) == text: return
	if not os.path.isdir(os.path.dirname(path)): os.makedirs(os.path.dirname(path))
	f = open(path, 'w')
	f.write(text)
	f.close()

if not os.path.isdir(root1 + svgdir) and os.path.isdir(root0 + svgdir):
	dir = os.path.dirname(re.sub('/$', '', root1 + svgdir))
	if not os.path.isdir(dir): os.makedirs(dir)
	os.renames(root0 + svgdir, root1 + svgdir)
if not os.path.isdir(root2 + workdir): os.makedirs(root2 + workdir)
if not os.path.isdir(root2 + svgdir):  os.makedirs(root2 + svgdir)
if not os.path.isdir(root3 + svgdir):  os.makedirs(root3 + svgdir)
if not os.path.isdir(root3 + svndir) and os.path.isdir(root1 + svndir):
	os.renames(root1 + svndir, root3 + svndir)

sm   = 'symbol__major__'
sf   = 'symbol__function__'
gf   = 'godan__function__'
tf   = 'twelvekeys__function__'
qf   = 'qwerty__function__'
gks  = 'godan__kana__support__'
gk   = 'godan__kana__'
tks  = 'twelvekeys__kana__support__'
tkk  = 'twelvekeys__kana__keyicon__'
tk   = 'twelvekeys__kana__'
tas  = 'twelvekeys__alphabet__support__'
ta   = 'twelvekeys__alphabet__'
tns  = 'twelvekeys__number__support__'
tn   = 'twelvekeys__number__'
nks  = 'niko__kana__support__'
nk   = 'niko__kana__'
bks  = 'bell__kana__support__'
bk   = 'bell__kana__'
qkfc = 'qwerty__keyicon__fullwidth_latin_capital_letter_'
qkfs = 'qwerty__keyicon__fullwidth_latin_small_letter_'
qkf  = 'qwerty__keyicon__fullwidth_'
qkc  = 'qwerty__keyicon__latin_capital_letter_'
qks  = 'qwerty__keyicon__latin_small_letter_'
qk   = 'qwerty__keyicon__'

for name, params in sorted({
	'emoji_disable_icon':				{'w': 16, 'h': 16, 's': 12, '': '！'},
	'keyboard_fold_tab_down':			{'w': 16, 'h': 16, 's': 12, '': ''},
	'keyboard_fold_tab_up':				{'w': 16, 'h': 16, 's': 12, '': ''},
	'adjust_arrow_left':				{'w': 16, 'h': 32, 's': 12, '': ''},
	'adjust_arrow_right':				{'w': 16, 'h': 32, 's': 12, '': ''},
	'hardware__function__close':		{'w': 64, 'h': 40, 's': 12, '': ''},
	sm + 'emoji':						{'w': 37, 'h': 66, 's': 16, '': ''},
	sm + 'emoji_selected':				{'w': 37, 'h': 66, 's': 16, '': ''},
	sm + 'emoticon':					{'w': 61, 'h': 66, 's': 16, '': '(^^)'},
	sm + 'emoticon_selected':			{'w': 61, 'h': 66, 's': 16, '': '(^^)'},
	sm + 'symbol':						{'w': 85, 'h': 66, 's': 16, '': '「」♪～'},
	sm + 'symbol_selected':				{'w': 85, 'h': 66, 's': 16, '': '「」♪～'},
	sf + 'close':						{'w': 51, 'h': 70, 's': 16, 'y': +8, '': '閉じる'},
	sf + 'delete':						{'w': 51, 'h': 70, 's': 16, 'y': +8, '': '削除'},
	gf + 'kana__icon5':					{'w': 82, 'h':140, 's': [14, 20], 'c':  0, '': ['設定', 'あ', 'Ａ', '１']},
	tf + 'kana__icon5':					{'w': 82, 'h': 87, 's': [14, 20], 'c':  0, '': ['設定', 'あ', 'Ａ', '１']},
	qf + 'kana__icon5':					{'w': 70, 'h': 74, 's': [14, 20], 'c':  0, '': ['設定', 'あ', 'Ａ', '１']},
	tf + 'kana__popup5':				{'w': 82, 'h': 87, 's': [14, 20], 'c':  0, '': ['設定', 'あ', 'Ａ', '１']},
	gf + 'alphabet__icon5':				{'w': 82, 'h':140, 's': [14, 20], 'c':  1, '': ['設定', 'Ａ', 'あ', '１'], 'n': gf + 'kana__icon'},
	tf + 'alphabet__icon5':				{'w': 82, 'h': 87, 's': [14, 20], 'c':  1, '': ['設定', 'Ａ', 'あ', '１'], 'n': tf + 'kana__icon'},
	qf + 'alphabet__icon5':				{'w': 70, 'h': 74, 's': [14, 20], 'c':  1, '': ['設定', 'Ａ', 'あ', '１'], 'n': qf + 'kana__icon'},
	tf + 'alphabet__popup5':			{'w': 82, 'h': 87, 's': [14, 20], 'c':  1, '': ['設定', 'Ａ', 'あ', '１'], 'n': tf + 'kana__popup'},
	gf + 'number__icon5':				{'w': 82, 'h':140, 's': [14, 20], 'c':  2, '': ['設定', '１', 'あ', 'Ａ'], 'n': gf + 'kana__icon'},
	tf + 'number__icon5':				{'w': 82, 'h': 87, 's': [14, 20], 'c':  2, '': ['設定', '１', 'あ', 'Ａ'], 'n': tf + 'kana__icon'},
	qf + 'number__icon5':				{'w': 70, 'h': 74, 's': [14, 20], 'c':  2, '': ['設定', '１', 'あ', 'Ａ'], 'n': qf + 'kana__icon'},
	tf + 'number__popup5':				{'w': 82, 'h': 87, 's': [14, 20], 'c':  2, '': ['設定', '１', 'あ', 'Ａ'], 'n': tf + 'kana__popup'},
	qf + 'text_kana__icon5':			{'w': 70, 'h': 74, 's': [24, 14], '': ['あいう', '', '設定', '', '']},
	qf + 'text_kana__popup5':			{'w': 70, 'h': 74, 's': [24, 14], '': ['あいう', '', '設定', '', '']},
	qf + 'text_alphabet__icon5':		{'w': 70, 'h': 74, 's': [24, 14], '': ['abc',    '', '設定', '', '']},
	qf + 'text_alphabet__popup5':		{'w': 70, 'h': 74, 's': [24, 14], '': ['abc',    '', '設定', '', '']},
	qf + 'number_kana__icon5':			{'w': 70, 'h': 74, 's': [24, 14], '': ['123',  '', 'IME', '', 'Mush']},
	qf + 'number_kana__popup5':			{'w': 70, 'h': 74, 's': [24, 14], '': ['123',  '', 'IME', '', 'Mush']},
	qf + 'number_alphabet__icon5':		{'w': 70, 'h': 74, 's': [24, 14], '': ['123',  '', 'IME', '', 'Mush']},
	qf + 'number_alphabet__popup5':		{'w': 70, 'h': 74, 's': [24, 14], '': ['123',  '', 'IME', '', 'Mush']},
	gf + 'symbol__icon5':				{'w': 82, 'h': 70, 's': [24, 14], '': ['記号', '', 'IME', '', 'Mush']},
	tf + 'symbol__icon5':				{'w': 82, 'h': 87, 's': [24, 14], '': ['記号', '', 'IME', '', 'Mush']},
	qf + 'symbol__icon5':				{'w': 70, 'h': 74, 's': [24, 14], '': ['記号', '', 'IME', '', 'Mush']},
	qf + 'symbol__popup5':				{'w': 70, 'h': 74, 's': [24, 14], '': ['記号', '', 'IME', '', 'Mush']},
	gf + 'space__icon5':				{'w': 82, 'h': 70, 's': [24, 14], '': ['', '', '半', '', '全']},
	tf + 'space__icon5':				{'w': 82, 'h': 87, 's': [24, 14], '': ['', '', '半', '', '全']},
	qf + 'space__icon5':				{'w': 70, 'h': 74, 's': [24, 14], '': ['', '', '半', '', '全']},
	qf + 'space__popup5':				{'w': 70, 'h': 74, 's': [24, 14], '': ['', '', '半', '', '全']},
	qk + 'space__icon5':				{'w': 70, 'h': 74, 's': [24, 14], 'k':  1, '': ['', '', '半', '', '全'], 'n': qf + 'space__icon'},
	qk + 'space__popup5':				{'w': 70, 'h': 74, 's': [24, 14], 'k':  1, '': ['', '', '半', '', '全'], 'n': qf + 'space__popup'},
	gf + 'kana__icon':					{'w': 82, 'h':140, 's': [20, 20], 'c': -2, '': ['あ', 'ａ']},
	tf + 'kana__icon':					{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	tf + 'kana__popup':					{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	qf + 'kana__icon':					{'w': 70, 'h': 74, 's': [20, 20], 'c': -2, '': ['あ', 'ａ']},
	qf + 'kana__popup':					{'w': 70, 'h': 74, 's': [20, 20], 'c': -2, '': ['あ', 'ａ']},
	tf + 'alphabet__icon':				{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	tf + 'alphabet__popup':				{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	qf + 'alphabet__icon':				{'w': 70, 'h': 74, 's': [20, 20], 'c': -2, '': ['あ', 'ａ']},
	qf + 'alphabet__popup':				{'w': 70, 'h': 74, 's': [20, 20], 'c': -2, '': ['あ', 'ａ']},
	tf + 'number__icon':				{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	tf + 'number__popup':				{'w': 82, 'h': 87, 's': [20, 20], 'c': -3, '': ['あ', 'Ａ', '１']},
	qf + 'number_kana__icon':			{'w': 70, 'h': 74, 's': [24, 20], 'y': -8, '': ['123', '',  '',  '', '時※']},
	qf + 'number_kana__popup':			{'w': 70, 'h': 74, 's': [24, 20], 'y': -8, '': ['123', '',  '',  '', '時※']},
	qf + 'number_alphabet__icon':		{'w': 70, 'h': 74, 's': [24, 20], 'y': -8, '': ['123', '',  '',  '', '$;']},
	qf + 'number_alphabet__popup':		{'w': 70, 'h': 74, 's': [24, 20], 'y': -8, '': ['123', '',  '',  '', '$;']},
	qf + 'text_kana__icon':				{'w': 70, 'h': 74, 's': 24, '': 'あいう'},
	qf + 'text_kana__popup':			{'w': 70, 'h': 74, 's': 24, '': 'あいう'},
	qf + 'text_alphabet__icon':			{'w': 70, 'h': 74, 's': 24, '': 'abc'},
	qf + 'text_alphabet__popup':		{'w': 70, 'h': 74, 's': 24, '': 'abc'},
	gf + 'symbol__icon':				{'w': 82, 'h': 70, 's': 24, '': '記号'},
	tf + 'symbol__icon':				{'w': 82, 'h': 87, 's': 24, '': '記号'},
	qf + 'symbol__icon':				{'w': 70, 'h': 74, 's': 24, '': '記号'},
	qf + 'symbol__popup':				{'w': 70, 'h': 74, 's': 24, '': '記号'},
	gf + 'preferences__icon':			{'w': 82, 'h':140, 's': 24, '': '設定', 'n': qf + 'text_kana__icon'},
	tf + 'preferences__icon':			{'w': 82, 'h': 87, 's': 24, '': '設定', 'n': qf + 'text_kana__icon'},
	qf + 'preferences__icon':			{'w': 70, 'h': 74, 's': 24, '': '設定', 'n': qf + 'text_kana__icon'},
	qf + 'preferences__popup':			{'w': 70, 'h': 74, 's': 24, '': '設定', 'n': qf + 'text_kana__popup'},
	gf + 'input_method__icon':			{'w': 82, 'h': 70, 's': 24, '': 'IME', 'n': qf + 'text_kana__icon'},
	tf + 'input_method__icon':			{'w': 82, 'h': 87, 's': 24, '': 'IME', 'n': qf + 'text_kana__icon'},
	qf + 'input_method__icon':			{'w': 70, 'h': 74, 's': 24, '': 'IME', 'n': qf + 'text_kana__icon'},
	qf + 'input_method__popup':			{'w': 70, 'h': 74, 's': 24, '': 'IME', 'n': qf + 'text_kana__popup'},
	gf + 'mushroom__icon':				{'w': 82, 'h': 70, 's': 24, '': 'Mush', 'n': qf + 'text_kana__icon'},
	tf + 'mushroom__icon':				{'w': 82, 'h': 87, 's': 24, '': 'Mush', 'n': qf + 'text_kana__icon'},
	qf + 'mushroom__icon':				{'w': 70, 'h': 74, 's': 24, '': 'Mush', 'n': qf + 'text_kana__icon'},
	qf + 'mushroom__popup':				{'w': 70, 'h': 74, 's': 24, '': 'Mush', 'n': qf + 'text_kana__popup'},
	gf + 'escape__icon':				{'w': 82, 'h': 70, 's': 24, '': 'Esc', 'n': qf + 'text_kana__icon'},
	tf + 'escape__icon':				{'w': 82, 'h': 87, 's': 24, '': 'Esc', 'n': qf + 'text_kana__icon'},
	qf + 'escape__icon':				{'w': 70, 'h': 74, 's': 24, '': 'Esc', 'n': qf + 'text_kana__icon'},
	qf + 'escape__popup':				{'w': 70, 'h': 74, 's': 24, '': 'Esc', 'n': qf + 'text_kana__popup'},
	qk + 'escape__icon':				{'w': 70, 'h': 74, 's': 24, 'k':  1, '': 'Esc', 'n': qf + 'text_kana__icon'},
	qk + 'escape__popup':				{'w': 70, 'h': 74, 's': 24, 'k':  1, '': 'Esc', 'n': qf + 'text_kana__popup'},
	gf + 'tab__icon':					{'w': 82, 'h': 70, 's': 24, '': 'Tab', 'n': qf + 'text_kana__icon'},
	tf + 'tab__icon':					{'w': 82, 'h': 87, 's': 24, '': 'Tab', 'n': qf + 'text_kana__icon'},
	qf + 'tab__icon':					{'w': 70, 'h': 74, 's': 24, '': 'Tab', 'n': qf + 'text_kana__icon'},
	qf + 'tab__popup':					{'w': 70, 'h': 74, 's': 24, '': 'Tab', 'n': qf + 'text_kana__popup'},
	qk + 'tab__icon':					{'w': 70, 'h': 74, 's': 24, 'k':  1, '': 'Tab', 'n': qf + 'text_kana__icon'},
	qk + 'tab__popup':					{'w': 70, 'h': 74, 's': 24, 'k':  1, '': 'Tab', 'n': qf + 'text_kana__popup'},
	gf + 'space__icon':					{'w': 82, 'h': 70, 's': 24, '': ''},
	tf + 'space__icon':					{'w': 82, 'h': 87, 's': 24, '': ''},
	qf + 'space__icon':					{'w': 70, 'h': 74, 's': 24, '': ''},
	qf + 'space__popup':				{'w': 70, 'h': 74, 's': 24, '': ''},
	qk + 'space__icon':					{'w': 70, 'h': 74, 's': 24, 'k':  1, '': '', 'n': qf + 'space__icon'},
	qk + 'space__popup':				{'w': 70, 'h': 74, 's': 24, 'k':  1, '': '', 'n': qf + 'space__popup'},
	gf + 'left_arrow__icon':			{'w': 82, 'h': 70, 's': 24, '': ''},
	tf + 'left_arrow__icon':			{'w': 82, 'h': 87, 's': 24, '': ''},
	tf + 'left_arrow__popup':			{'w': 82, 'h': 87, 's': 24, '': ''},
	gf + 'right_arrow__icon':			{'w': 82, 'h': 70, 's': 24, '': ''},
	tf + 'right_arrow__icon':			{'w': 82, 'h': 87, 's': 24, '': ''},
	tf + 'right_arrow__popup':			{'w': 82, 'h': 87, 's': 24, '': ''},
	gf + 'up_arrow__icon':				{'w': 82, 'h': 70, 's': 24, '': '▲', 'n': qf + 'text_kana__icon'},
	tf + 'up_arrow__icon':				{'w': 82, 'h': 87, 's': 24, '': '▲', 'n': qf + 'text_kana__icon'},
	tf + 'up_arrow__popup':				{'w': 82, 'h': 87, 's': 24, '': '▲', 'n': qf + 'text_kana__popup'},
	gf + 'down_arrow__icon':			{'w': 82, 'h': 70, 's': 24, '': '▼', 'n': qf + 'text_kana__icon'},
	tf + 'down_arrow__icon':			{'w': 82, 'h': 87, 's': 24, '': '▼', 'n': qf + 'text_kana__icon'},
	tf + 'down_arrow__popup':			{'w': 82, 'h': 87, 's': 24, '': '▼', 'n': qf + 'text_kana__popup'},
	qf + 'cursor__icon':				{'w': 70, 'h': 74, 's': 24, '': ''},
	gf + 'undo__icon':					{'w': 82, 'h': 70, 's': 24, 'y': +8, '': '戻す'},
	tf + 'undo__icon':					{'w': 82, 'h': 87, 's': 24, 'y': +8, '': '戻す'},
	tf + 'undo__popup':					{'w': 82, 'h': 87, 's': 24, 'y': +8, '': '戻す'},
	gf + 'delete__icon':				{'w': 82, 'h': 70, 's': 24, '': ''},
	tf + 'delete__icon':				{'w': 82, 'h': 87, 's': 24, '': ''},
	qf + 'delete__icon':				{'w': 70, 'h': 74, 's': 24, '': ''},
	qf + 'delete__popup':				{'w': 70, 'h': 74, 's': 24, '': ''},
	gf + 'enter__icon':					{'w': 82, 'h':140, 's': 24, '': ''},
	tf + 'enter__icon':					{'w': 82, 'h': 87, 's': 24, '': ''},
	qf + 'enter__icon':					{'w': 70, 'h': 74, 's': 24, '': ''},
	qf + 'enter__popup':				{'w': 70, 'h': 74, 's': 24, '': ''},
	qf + 'alt__icon':					{'w': 70, 'h': 74, 's': 24, '': 'ALT'},
	'qwerty__caps_on':					{'w': 70, 'h': 74, 's': 24, 'y': -8, '': 'Caps'},
	'qwerty__shift_off':				{'w': 70, 'h': 74, 's': 24, 'y': -8, '': 'Shift'},
	'qwerty__shift_on':					{'w': 70, 'h': 74, 's': 24, 'y': -8, '': 'Shift'},
	gks + '01_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ａ',   '',   '',   '', '１']},
	gks + '02_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｋ',   '', 'Ｑ', 'Ｇ', '２']},
	gks + '03_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｈ', 'Ｐ', 'Ｆ', 'Ｂ', '３']},
	gks + '04_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｉ',   '',   '',   '', '４']},
	gks + '05_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｓ',   '', 'Ｊ', 'Ｚ', '５']},
	gks + '06_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｍ', '／', 'Ｌ', 'ー', '６']},
	gks + '07_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｕ',   '',   '',   '', '７']},
	gks + '08_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｔ',   '', 'Ｃ', 'Ｄ', '８']},
	gks + '09_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｙ', '（', 'Ｘ', '）', '９']},
	gks + '10_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｅ',   '',   '',   '',   '']},
	gks + '11_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｎ', '：', 'ん', '・', '０']},
	gks + '12_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｒ', '。', '？', '！', '、']},
	gks + '13_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｏ',   '',   '',   '',   '']},
	gks + '15_release':					{'w':105, 'h': 70, 's': [32, 20], '': ['Ｗ', '「', 'Ｖ', '」',   '']},
	gk + '14':							{'w':105, 'h': 70, 's': [32, 20], '': ['大', '゛', '小', '゜',   '']},
	gks + '01_center':					{'w':105, 'h': 70, 's': 32, '': 'Ａ'},
	gks + '01_down':					{'w':105, 'h': 70, 's': 32, '': '１'},
	gks + '02_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｋ'},
	gks + '02_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｑ'},
	gks + '02_right':					{'w':105, 'h': 70, 's': 32, '': 'Ｇ'},
	gks + '02_down':					{'w':105, 'h': 70, 's': 32, '': '２'},
	gks + '03_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｈ'},
	gks + '03_left':					{'w':105, 'h': 70, 's': 32, '': 'Ｐ'},
	gks + '03_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｆ'},
	gks + '03_right':					{'w':105, 'h': 70, 's': 32, '': 'Ｂ'},
	gks + '03_down':					{'w':105, 'h': 70, 's': 32, '': '３'},
	gks + '04_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｉ'},
	gks + '04_down':					{'w':105, 'h': 70, 's': 32, '': '４'},
	gks + '05_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｓ'},
	gks + '05_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｊ'},
	gks + '05_right':					{'w':105, 'h': 70, 's': 32, '': 'Ｚ'},
	gks + '05_down':					{'w':105, 'h': 70, 's': 32, '': '５'},
	gks + '06_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｍ'},
	gks + '06_left':					{'w':105, 'h': 70, 's': 32, '': '／', 'n': gks + '03_left'},
	gks + '06_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｌ'},
	gks + '06_right':					{'w':105, 'h': 70, 's': 32, '': 'ー'},
	gks + '06_down':					{'w':105, 'h': 70, 's': 32, '': '６'},
	gks + '07_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｕ'},
	gks + '07_down':					{'w':105, 'h': 70, 's': 32, '': '７'},
	gks + '08_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｔ'},
	gks + '08_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｃ'},
	gks + '08_right':					{'w':105, 'h': 70, 's': 32, '': 'Ｄ'},
	gks + '08_down':					{'w':105, 'h': 70, 's': 32, '': '８'},
	gks + '09_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｙ'},
	gks + '09_left':					{'w':105, 'h': 70, 's': 32, '': '（', 'n': gks + '03_left'},
	gks + '09_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｘ'},
	gks + '09_right':					{'w':105, 'h': 70, 's': 32, '': '）', 'n': gks + '03_right'},
	gks + '09_down':					{'w':105, 'h': 70, 's': 32, '': '９'},
	gks + '10_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｅ'},
	gks + '11_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｎ'},
	gks + '11_left':					{'w':105, 'h': 70, 's': 32, '': '：', 'n': gks + '03_left'},
	gks + '11_up':						{'w':105, 'h': 70, 's': 32, '': 'ん', 'n': gks + '03_up'},
	gks + '11_right':					{'w':105, 'h': 70, 's': 32, '': '・', 'n': gks + '03_right'},
	gks + '11_down':					{'w':105, 'h': 70, 's': 32, '': '０'},
	gks + '12_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｒ'},
	gks + '12_left':					{'w':105, 'h': 70, 's': 32, '': '。'},
	gks + '12_up':						{'w':105, 'h': 70, 's': 32, '': '？'},
	gks + '12_right':					{'w':105, 'h': 70, 's': 32, '': '！'},
	gks + '12_down':					{'w':105, 'h': 70, 's': 32, '': '、'},
	gks + '13_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｏ'},
	gks + '15_center':					{'w':105, 'h': 70, 's': 32, '': 'Ｗ'},
	gks + '15_left':					{'w':105, 'h': 70, 's': 32, '': '「', 'n': gks + '03_left'},
	gks + '15_up':						{'w':105, 'h': 70, 's': 32, '': 'Ｖ'},
	gks + '15_right':					{'w':105, 'h': 70, 's': 32, '': '」', 'n': gks + '03_right'},
	nk + '01':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['あ',   '',  '.','-@_',  '1'], 'n': tks + '01_release'},
	nk + '02':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['か',   '', 'ヶ','ABC',  '2'], 'n': tks + '02_release'},
	nk + '03':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['さ',   '',   '','DEF',  '3'], 'n': tks + '03_release'},
	nk + '04':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['た',   '', 'っ','GHI',  '4'], 'n': tks + '04_release'},
	nk + '05':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['な',   '',   '','JKL',  '5'], 'n': tks + '05_release'},
	nk + '06':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['は',   '',   '','MNO',  '6'], 'n': tks + '06_release'},
	nk + '07':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['ま',   '',  'P','QRS',  '7'], 'n': tks + '07_release'},
	nk + '08':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['や','','ゃゅょ','TUV',  '8'], 'n': tks + '08_release'},
	nk + '09':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['ら',   '',  'W','XYZ',  '9'], 'n': tks + '09_release'},
	nk + '10':							{'w':105, 'h': 87, 's': [32, 20], '': ['大', '゛', '小', '゜',   ''], 'n': tk + '10'},
	nk + '11':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['わ',   '','､｡ｰ','･!?',  '0'], 'n': tks + '11_release'},
	nk + '12':							{'w':105, 'h': 87, 's': [32, 20], '': ['、', '。', '？', '！',   ''], 'n': tks + '12_release'},
	bk + '01':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['あ',   '',  'A','BCD',  'E'], 'n': tks + '01_release'},
	bk + '02':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['か',   '',  'F','GHI',  'J'], 'n': tks + '02_release'},
	bk + '03':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['さ',   '',  'K','LMN',  'O'], 'n': tks + '03_release'},
	bk + '04':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['た',   '',  'P','QRS',  'T'], 'n': tks + '04_release'},
	bk + '05':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['な',   '',  'U','VWX',  'Y'], 'n': tks + '05_release'},
	bk + '06':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['は',   '',  'Z','?!ｰ',  '/'], 'n': tks + '06_release'},
	bk + '07':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['ま',   '', '\\','&+=',  '･'], 'n': tks + '07_release'},
	bk + '08':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['や',  '','() *','# @', 'っ'], 'n': tks + '08_release'},
	bk + '09':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['ら',   '',  '1','234',  '5'], 'n': tks + '09_release'},
	bk + '10':							{'w':105, 'h': 87, 's': [32, 20], '': ['大', '゛', '小', '゜',   ''], 'n': tk + '10'},
	bk + '11':							{'w':105, 'h': 87, 's': [32, 20], 'b':  1, '': ['わ',   '','､｡6','789',  '0'], 'n': tks + '11_release'},
	bk + '12':							{'w':105, 'h': 87, 's': [32, 20], '': ['、', '。', '？', '！',   ''], 'n': tks + '12_release'},
	tks + '01_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['あ', 'い', 'う', 'え', 'お']},
	tks + '02_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['か', 'き', 'く', 'け', 'こ']},
	tks + '03_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['さ', 'し', 'す', 'せ', 'そ']},
	tks + '04_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['た', 'ち', 'つ', 'て', 'と']},
	tks + '05_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['な', 'に', 'ぬ', 'ね', 'の']},
	tks + '06_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['は', 'ひ', 'ふ', 'へ', 'ほ']},
	tks + '07_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['ま', 'み', 'む', 'め', 'も']},
	tks + '08_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['や',   '', 'ゆ',   '', 'よ']},
	tks + '09_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['ら', 'り', 'る', 'れ', 'ろ']},
	tk + '10':							{'w':105, 'h': 87, 's': [32, 20], '': ['大', '゛', '小', '゜',   '']},
	tks + '11_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['わ', 'を', 'ん', 'ー',   '']},
	tks + '12_release':					{'w':105, 'h': 87, 's': [32, 20], '': ['、', '。', '？', '！',   '']},
	ta + '01':							{'w':105, 'h': 87, 's': [32, 20], '': [ '@',  '-',  '_',  '/',  '&']},
	ta + '02':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'A',  'B',  'C',   '',   '']},
	ta + '03':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'D',  'E',  'F',   '',   '']},
	ta + '04':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'G',  'H',  'I',   '',   '']},
	ta + '05':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'J',  'K',  'L',   '',   '']},
	ta + '06':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'M',  'N',  'O',   '',   '']},
	ta + '07':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'P',  'Q',  'R',  'S',   '']},
	ta + '08':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'T',  'U',  'V',   '',   '']},
	ta + '09':							{'w':105, 'h': 87, 's': [32, 20], '': [ 'W',  'X',  'Y',  'Z',   '']},
	ta + '10':							{'w':105, 'h': 87, 's': 32, '': 'a⇔A'},
	ta + '11':							{'w':105, 'h': 87, 's': [32, 20], '': [ "'",  '"',  ':',  ';',   '']},
	ta + '12':							{'w':105, 'h': 87, 's': [32, 20], '': [ '.',  ',',  '?',  '!',   '']},
	ta + '5__01':						{'w':105, 'h': 87, 's': [32, 20], '': [ '@',  '-',  '_',  '/',  '1'], 'n': ta + '01'},
	ta + '5__02':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'A',  'B',  'C',  '(',  '2'], 'n': ta + '02'},
	ta + '5__03':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'D',  'E',  'F',  ')',  '3'], 'n': ta + '03'},
	ta + '5__04':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'G',  'H',  'I',  '=',  '4'], 'n': ta + '04'},
	ta + '5__05':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'J',  'K',  'L',  '+',  '5'], 'n': ta + '05'},
	ta + '5__06':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'M',  'N',  'O',  '*',  '6'], 'n': ta + '06'},
	ta + '5__07':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'P',  'Q',  'R',  'S',  '7'], 'n': ta + '07'},
	ta + '5__08':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'T',  'U',  'V',  '%',  '8'], 'n': ta + '08'},
	ta + '5__09':						{'w':105, 'h': 87, 's': [32, 20], '': [ 'W',  'X',  'Y',  'Z',  '9'], 'n': ta + '09'},
	ta + '5__10':						{'w':105, 'h': 87, 's': 32, '': 'a⇔A', 'n': ta + '10'},
	ta + '5__11':						{'w':105, 'h': 87, 's': [32, 20], '': [ "'",  '"',  ':',  ';',  '0'], 'n': ta + '11'},
	ta + '5__12':						{'w':105, 'h': 87, 's': [32, 20], '': [ '.',  ',',  '?',  '!',  '&'], 'n': ta + '12'},
	tn + '01':							{'w':105, 'h': 87, 's': 32, '':  '1'},
	tn + '02':							{'w':105, 'h': 87, 's': 32, '':  '2'},
	tn + '03':							{'w':105, 'h': 87, 's': 32, '':  '3'},
	tn + '04':							{'w':105, 'h': 87, 's': 32, '':  '4'},
	tn + '05':							{'w':105, 'h': 87, 's': 32, '':  '5'},
	tn + '06':							{'w':105, 'h': 87, 's': 32, '':  '6'},
	tn + '07':							{'w':105, 'h': 87, 's': 32, '':  '7'},
	tn + '08':							{'w':105, 'h': 87, 's': 32, '':  '8'},
	tn + '09':							{'w':105, 'h': 87, 's': 32, '':  '9'},
	tn + '10':							{'w':105, 'h': 87, 's': [32, 20], '': [ '/',  '~',  '.',  '*',   '']},
	tn + '11':							{'w':105, 'h': 87, 's': 32, '':  '0'},
	tn + '12':							{'w':105, 'h': 87, 's': [32, 20], '': [ '+',  '-',  '=',  '#',   '']},
	tn + '5__10':						{'w':105, 'h': 87, 's': [32, 20], '': [ '/',  '~',  '.',  '*',  ','], 'n': tn + '10'},
	tn + '5__12':						{'w':105, 'h': 87, 's': [32, 20], '': [ '+',  '-',  '=',  '#',  ':'], 'n': tn + '12'},
	tks + '01_center':					{'w':105, 'h': 87, 's': 32, '': 'あ'},
	tks + '01_left':					{'w':105, 'h': 87, 's': 32, '': 'い'},
	tks + '01_up':						{'w':105, 'h': 87, 's': 32, '': 'う'},
	tks + '01_right':					{'w':105, 'h': 87, 's': 32, '': 'え'},
	tks + '01_down':					{'w':105, 'h': 87, 's': 32, '': 'お'},
	tks + '02_center':					{'w':105, 'h': 87, 's': 32, '': 'か'},
	tks + '02_left':					{'w':105, 'h': 87, 's': 32, '': 'き'},
	tks + '02_up':						{'w':105, 'h': 87, 's': 32, '': 'く'},
	tks + '02_right':					{'w':105, 'h': 87, 's': 32, '': 'け'},
	tks + '02_down':					{'w':105, 'h': 87, 's': 32, '': 'こ'},
	tks + '03_center':					{'w':105, 'h': 87, 's': 32, '': 'さ'},
	tks + '03_left':					{'w':105, 'h': 87, 's': 32, '': 'し'},
	tks + '03_up':						{'w':105, 'h': 87, 's': 32, '': 'す'},
	tks + '03_right':					{'w':105, 'h': 87, 's': 32, '': 'せ'},
	tks + '03_down':					{'w':105, 'h': 87, 's': 32, '': 'そ'},
	tks + '04_center':					{'w':105, 'h': 87, 's': 32, '': 'た'},
	tks + '04_left':					{'w':105, 'h': 87, 's': 32, '': 'ち'},
	tks + '04_up':						{'w':105, 'h': 87, 's': 32, '': 'つ'},
	tks + '04_right':					{'w':105, 'h': 87, 's': 32, '': 'て'},
	tks + '04_down':					{'w':105, 'h': 87, 's': 32, '': 'と'},
	tks + '05_center':					{'w':105, 'h': 87, 's': 32, '': 'な'},
	tks + '05_left':					{'w':105, 'h': 87, 's': 32, '': 'に'},
	tks + '05_up':						{'w':105, 'h': 87, 's': 32, '': 'ぬ'},
	tks + '05_right':					{'w':105, 'h': 87, 's': 32, '': 'ね'},
	tks + '05_down':					{'w':105, 'h': 87, 's': 32, '': 'の'},
	tks + '06_center':					{'w':105, 'h': 87, 's': 32, '': 'は'},
	tks + '06_left':					{'w':105, 'h': 87, 's': 32, '': 'ひ'},
	tks + '06_up':						{'w':105, 'h': 87, 's': 32, '': 'ふ'},
	tks + '06_right':					{'w':105, 'h': 87, 's': 32, '': 'へ'},
	tks + '06_down':					{'w':105, 'h': 87, 's': 32, '': 'ほ'},
	tks + '07_center':					{'w':105, 'h': 87, 's': 32, '': 'ま'},
	tks + '07_left':					{'w':105, 'h': 87, 's': 32, '': 'み'},
	tks + '07_up':						{'w':105, 'h': 87, 's': 32, '': 'む'},
	tks + '07_right':					{'w':105, 'h': 87, 's': 32, '': 'め'},
	tks + '07_down':					{'w':105, 'h': 87, 's': 32, '': 'も'},
	tks + '08_center':					{'w':105, 'h': 87, 's': 32, '': 'や'},
	tks + '08_up':						{'w':105, 'h': 87, 's': 32, '': 'ゆ'},
	tks + '08_down':					{'w':105, 'h': 87, 's': 32, '': 'よ'},
	tks + '09_center':					{'w':105, 'h': 87, 's': 32, '': 'ら'},
	tks + '09_left':					{'w':105, 'h': 87, 's': 32, '': 'り'},
	tks + '09_up':						{'w':105, 'h': 87, 's': 32, '': 'る'},
	tks + '09_right':					{'w':105, 'h': 87, 's': 32, '': 'れ'},
	tks + '09_down':					{'w':105, 'h': 87, 's': 32, '': 'ろ'},
	tks + '11_center':					{'w':105, 'h': 87, 's': 32, '': 'わ'},
	tks + '11_left':					{'w':105, 'h': 87, 's': 32, '': 'を'},
	tks + '11_up':						{'w':105, 'h': 87, 's': 32, '': 'ん'},
	tks + '11_right':					{'w':105, 'h': 87, 's': 32, '': 'ー'},
	tks + '12_center':					{'w':105, 'h': 87, 's': 32, '': '、'},
	tks + '12_left':					{'w':105, 'h': 87, 's': 32, '': '。'},
	tks + '12_up':						{'w':105, 'h': 87, 's': 32, '': '？'},
	tks + '12_right':					{'w':105, 'h': 87, 's': 32, '': '！'},
	tk + 'simple__12':					{'w':105, 'h': 87, 's': 24, '': '、。？！'},
	gks + 'popup__01':					{'w':112, 'h':112, 's': [40, 20], '': ['Ａ',   '',   '',   '', '１']},
	gks + 'popup__02':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｋ',   '', 'Ｑ', 'Ｇ', '２']},
	gks + 'popup__03':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｈ', 'Ｐ', 'Ｆ', 'Ｂ', '３']},
	gks + 'popup__04':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｉ',   '',   '',   '', '４']},
	gks + 'popup__05':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｓ',   '', 'Ｊ', 'Ｚ', '５']},
	gks + 'popup__06':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｍ', '／', 'Ｌ', 'ー', '６']},
	gks + 'popup__07':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｕ',   '',   '',   '', '７']},
	gks + 'popup__08':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｔ',   '', 'Ｃ', 'Ｄ', '８']},
	gks + 'popup__09':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｙ', '（', 'Ｘ', '）', '９']},
	gks + 'popup__10':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｅ',   '',   '',   '',   '']},
	gks + 'popup__11':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｎ', '：', 'ん', '・', '０']},
	gks + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｒ', '。', '？', '！', '、']},
	gks + 'popup__13':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｏ',   '',   '',   '',   '']},
	gks + 'popup__15':					{'w':112, 'h':112, 's': [40, 20], '': ['Ｗ', '「', 'Ｖ', '」',   '']},
	nk + 'popup__01':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['あ',   '',  '.','-@_',  '1'], 'n': tks + 'popup__01'},
	nk + 'popup__02':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['か',   '', 'ヶ','ABC',  '2'], 'n': tks + 'popup__02'},
	nk + 'popup__03':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['さ',   '',   '','DEF',  '3'], 'n': tks + 'popup__03'},
	nk + 'popup__04':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['た',   '', 'っ','GHI',  '4'], 'n': tks + 'popup__04'},
	nk + 'popup__05':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['な',   '',   '','JKL',  '5'], 'n': tks + 'popup__05'},
	nk + 'popup__06':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['は',   '',   '','MNO',  '6'], 'n': tks + 'popup__06'},
	nk + 'popup__07':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['ま',   '',  'P','QRS',  '7'], 'n': tks + 'popup__07'},
	nk + 'popup__08':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['や','','ゃゅょ','TUV',  '8'], 'n': tks + 'popup__08'},
	nk + 'popup__09':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['ら',   '',  'W','XYZ',  '9'], 'n': tks + 'popup__09'},
	nk + 'popup__10':					{'w':112, 'h':112, 's': [40, 20], '': ['大', '゛', '小', '゜',   ''], 'n': tk + 'popup__10'},
	nk + 'popup__11':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['わ',   '','､｡ｰ','･!?',  '0'], 'n': tks + 'popup__11'},
	nk + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': ['、', '。', '？', '！',   ''], 'n': tks + 'popup__12'},
	bk + 'popup__01':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['あ',   '',  'A','BCD',  'E'], 'n': tks + 'popup__01'},
	bk + 'popup__02':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['か',   '',  'F','GHI',  'J'], 'n': tks + 'popup__02'},
	bk + 'popup__03':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['さ',   '',  'K','LMN',  'O'], 'n': tks + 'popup__03'},
	bk + 'popup__04':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['た',   '',  'P','QRS',  'T'], 'n': tks + 'popup__04'},
	bk + 'popup__05':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['な',   '',  'U','VWX',  'Y'], 'n': tks + 'popup__05'},
	bk + 'popup__06':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['は',   '',  'Z','?!ｰ',  '/'], 'n': tks + 'popup__06'},
	bk + 'popup__07':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['ま',   '', '\\','&+=',  '･'], 'n': tks + 'popup__07'},
	bk + 'popup__08':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['や',  '','() *','# @', 'っ'], 'n': tks + 'popup__08'},
	bk + 'popup__09':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['ら',   '',  '1','234',  '5'], 'n': tks + 'popup__09'},
	bk + 'popup__10':					{'w':112, 'h':112, 's': [40, 20], '': ['大', '゛', '小', '゜',   ''], 'n': tk + 'popup__10'},
	bk + 'popup__11':					{'w':112, 'h':112, 's': [40, 20], 'b':  1, '': ['わ',   '','､｡6','789',  '0'], 'n': tks + 'popup__11'},
	bk + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': ['、', '。', '？', '！',   ''], 'n': tks + 'popup__12'},
	tks + 'popup__01':					{'w':112, 'h':112, 's': [40, 20], '': ['あ', 'い', 'う', 'え', 'お']},
	tks + 'popup__02':					{'w':112, 'h':112, 's': [40, 20], '': ['か', 'き', 'く', 'け', 'こ']},
	tks + 'popup__03':					{'w':112, 'h':112, 's': [40, 20], '': ['さ', 'し', 'す', 'せ', 'そ']},
	tks + 'popup__04':					{'w':112, 'h':112, 's': [40, 20], '': ['た', 'ち', 'つ', 'て', 'と']},
	tks + 'popup__05':					{'w':112, 'h':112, 's': [40, 20], '': ['な', 'に', 'ぬ', 'ね', 'の']},
	tks + 'popup__06':					{'w':112, 'h':112, 's': [40, 20], '': ['は', 'ひ', 'ふ', 'へ', 'ほ']},
	tks + 'popup__07':					{'w':112, 'h':112, 's': [40, 20], '': ['ま', 'み', 'む', 'め', 'も']},
	tks + 'popup__08':					{'w':112, 'h':112, 's': [40, 20], '': ['や',   '', 'ゆ',   '', 'よ']},
	tks + 'popup__09':					{'w':112, 'h':112, 's': [40, 20], '': ['ら', 'り', 'る', 'れ', 'ろ']},
	tk + 'popup__10':					{'w':112, 'h':112, 's': [40, 20], '': ['大', '゛', '小', '゜',   '']},
	tks + 'popup__11':					{'w':112, 'h':112, 's': [40, 20], '': ['わ', 'を', 'ん', 'ー',   '']},
	tks + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': ['、', '。', '？', '！',   '']},
	tas + 'popup__01':					{'w':112, 'h':112, 's': [40, 20], '': [ '@',  '-',  '_',  '/',  '&']},
	tas + 'popup__02':					{'w':112, 'h':112, 's': [40, 20], '': [ 'A',  'B',  'C',   '',   '']},
	tas + 'popup__03':					{'w':112, 'h':112, 's': [40, 20], '': [ 'D',  'E',  'F',   '',   '']},
	tas + 'popup__04':					{'w':112, 'h':112, 's': [40, 20], '': [ 'G',  'H',  'I',   '',   '']},
	tas + 'popup__05':					{'w':112, 'h':112, 's': [40, 20], '': [ 'J',  'K',  'L',   '',   '']},
	tas + 'popup__06':					{'w':112, 'h':112, 's': [40, 20], '': [ 'M',  'N',  'O',   '',   '']},
	tas + 'popup__07':					{'w':112, 'h':112, 's': [40, 20], '': [ 'P',  'Q',  'R',  'S',   '']},
	tas + 'popup__08':					{'w':112, 'h':112, 's': [40, 20], '': [ 'T',  'U',  'V',   '',   '']},
	tas + 'popup__09':					{'w':112, 'h':112, 's': [40, 20], '': [ 'W',  'X',  'Y',  'Z',   '']},
	tas + 'popup__11':					{'w':112, 'h':112, 's': [40, 20], '': [ "'",  '"',  ':',  ';',   '']},
	tas + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': [ '.',  ',',  '?',  '!',   '']},
	tas + 'popup5__01':					{'w':112, 'h':112, 's': [40, 20], '': [ '@',  '-',  '_',  '/',  '1'], 'n': tas + 'popup__01'},
	tas + 'popup5__02':					{'w':112, 'h':112, 's': [40, 20], '': [ 'A',  'B',  'C',  '(',  '2'], 'n': tas + 'popup__02'},
	tas + 'popup5__03':					{'w':112, 'h':112, 's': [40, 20], '': [ 'D',  'E',  'F',  ')',  '3'], 'n': tas + 'popup__03'},
	tas + 'popup5__04':					{'w':112, 'h':112, 's': [40, 20], '': [ 'G',  'H',  'I',  '=',  '4'], 'n': tas + 'popup__04'},
	tas + 'popup5__05':					{'w':112, 'h':112, 's': [40, 20], '': [ 'J',  'K',  'L',  '+',  '5'], 'n': tas + 'popup__05'},
	tas + 'popup5__06':					{'w':112, 'h':112, 's': [40, 20], '': [ 'M',  'N',  'O',  '*',  '6'], 'n': tas + 'popup__06'},
	tas + 'popup5__07':					{'w':112, 'h':112, 's': [40, 20], '': [ 'P',  'Q',  'R',  'S',  '7'], 'n': tas + 'popup__07'},
	tas + 'popup5__08':					{'w':112, 'h':112, 's': [40, 20], '': [ 'T',  'U',  'V',  '%',  '8'], 'n': tas + 'popup__08'},
	tas + 'popup5__09':					{'w':112, 'h':112, 's': [40, 20], '': [ 'W',  'X',  'Y',  'Z',  '9'], 'n': tas + 'popup__09'},
	tas + 'popup5__11':					{'w':112, 'h':112, 's': [40, 20], '': [ "'",  '"',  ':',  ';',  '0'], 'n': tas + 'popup__11'},
	tas + 'popup5__12':					{'w':112, 'h':112, 's': [40, 20], '': [ '.',  ',',  '?',  '!',  '&'], 'n': tas + 'popup__12'},
	tns + 'popup__10':					{'w':112, 'h':112, 's': [40, 20], '': [ '/',  '~',  '.',  '*',   '']},
	tns + 'popup__12':					{'w':112, 'h':112, 's': [40, 20], '': [ '+',  '-',  '=',  '#',   '']},
	tns + 'popup5__10':					{'w':112, 'h':112, 's': [40, 20], '': [ '/',  '~',  '.',  '*',  ','], 'n': tns + 'popup__10'},
	tns + 'popup5__12':					{'w':112, 'h':112, 's': [40, 20], '': [ '+',  '-',  '=',  '#',  ':'], 'n': tns + 'popup__12'},
	tkk + 'an':							{'w':112, 'h':112, 's': 40, '': 'あん'},
	tkk + 'axtu':						{'w':112, 'h':112, 's': 40, '': 'あっ'},
	tkk + 'xya':						{'w':112, 'h':112, 's': 40, '': 'ゃ'},
	tkk + 'in':							{'w':112, 'h':112, 's': 40, '': 'いん'},
	tkk + 'ixtu':						{'w':112, 'h':112, 's': 40, '': 'いっ'},
	tkk + 'xi':							{'w':112, 'h':112, 's': 40, '': 'ぃ'},
	tkk + 'un':							{'w':112, 'h':112, 's': 40, '': 'うん'},
	tkk + 'uxtu':						{'w':112, 'h':112, 's': 40, '': 'うっ'},
	tkk + 'xyu':						{'w':112, 'h':112, 's': 40, '': 'ゅ'},
	tkk + 'en':							{'w':112, 'h':112, 's': 40, '': 'えん'},
	tkk + 'extu':						{'w':112, 'h':112, 's': 40, '': 'えっ'},
	tkk + 'xe':							{'w':112, 'h':112, 's': 40, '': 'ぇ'},
	tkk + 'on':							{'w':112, 'h':112, 's': 40, '': 'おん'},
	tkk + 'oxtu':						{'w':112, 'h':112, 's': 40, '': 'おっ'},
	tkk + 'xyo':						{'w':112, 'h':112, 's': 40, '': 'ょ'},
	tkk + 'a':							{'w':112, 'h':112, 's': 40, '': 'あ'},
	tkk + 'i':							{'w':112, 'h':112, 's': 40, '': 'い'},
	tkk + 'u':							{'w':112, 'h':112, 's': 40, '': 'う'},
	tkk + 'e':							{'w':112, 'h':112, 's': 40, '': 'え'},
	tkk + 'o':							{'w':112, 'h':112, 's': 40, '': 'お'},
	tkk + 'ka':							{'w':112, 'h':112, 's': 40, '': 'か'},
	tkk + 'ki':							{'w':112, 'h':112, 's': 40, '': 'き'},
	tkk + 'ku':							{'w':112, 'h':112, 's': 40, '': 'く'},
	tkk + 'ke':							{'w':112, 'h':112, 's': 40, '': 'け'},
	tkk + 'ko':							{'w':112, 'h':112, 's': 40, '': 'こ'},
	tkk + 'sa':							{'w':112, 'h':112, 's': 40, '': 'さ'},
	tkk + 'shi':						{'w':112, 'h':112, 's': 40, '': 'し'},
	tkk + 'su':							{'w':112, 'h':112, 's': 40, '': 'す'},
	tkk + 'se':							{'w':112, 'h':112, 's': 40, '': 'せ'},
	tkk + 'so':							{'w':112, 'h':112, 's': 40, '': 'そ'},
	tkk + 'ta':							{'w':112, 'h':112, 's': 40, '': 'た'},
	tkk + 'chi':						{'w':112, 'h':112, 's': 40, '': 'ち'},
	tkk + 'tsu':						{'w':112, 'h':112, 's': 40, '': 'つ'},
	tkk + 'te':							{'w':112, 'h':112, 's': 40, '': 'て'},
	tkk + 'to':							{'w':112, 'h':112, 's': 40, '': 'と'},
	tkk + 'na':							{'w':112, 'h':112, 's': 40, '': 'な'},
	tkk + 'ni':							{'w':112, 'h':112, 's': 40, '': 'に'},
	tkk + 'nu':							{'w':112, 'h':112, 's': 40, '': 'ぬ'},
	tkk + 'ne':							{'w':112, 'h':112, 's': 40, '': 'ね'},
	tkk + 'no':							{'w':112, 'h':112, 's': 40, '': 'の'},
	tkk + 'ha':							{'w':112, 'h':112, 's': 40, '': 'は'},
	tkk + 'hi':							{'w':112, 'h':112, 's': 40, '': 'ひ'},
	tkk + 'fu':							{'w':112, 'h':112, 's': 40, '': 'ふ'},
	tkk + 'he':							{'w':112, 'h':112, 's': 40, '': 'へ'},
	tkk + 'ho':							{'w':112, 'h':112, 's': 40, '': 'ほ'},
	tkk + 'ma':							{'w':112, 'h':112, 's': 40, '': 'ま'},
	tkk + 'mi':							{'w':112, 'h':112, 's': 40, '': 'み'},
	tkk + 'mu':							{'w':112, 'h':112, 's': 40, '': 'む'},
	tkk + 'me':							{'w':112, 'h':112, 's': 40, '': 'め'},
	tkk + 'mo':							{'w':112, 'h':112, 's': 40, '': 'も'},
	tkk + 'ya':							{'w':112, 'h':112, 's': 40, '': 'や'},
	tkk + 'yu':							{'w':112, 'h':112, 's': 40, '': 'ゆ'},
	tkk + 'yo':							{'w':112, 'h':112, 's': 40, '': 'よ'},
	tkk + 'ra':							{'w':112, 'h':112, 's': 40, '': 'ら'},
	tkk + 'ri':							{'w':112, 'h':112, 's': 40, '': 'り'},
	tkk + 'ru':							{'w':112, 'h':112, 's': 40, '': 'る'},
	tkk + 're':							{'w':112, 'h':112, 's': 40, '': 'れ'},
	tkk + 'ro':							{'w':112, 'h':112, 's': 40, '': 'ろ'},
	tkk + 'wa':							{'w':112, 'h':112, 's': 40, '': 'わ'},
	tkk + 'wo':							{'w':112, 'h':112, 's': 40, '': 'を'},
	tkk + 'nn':							{'w':112, 'h':112, 's': 40, '': 'ん'},
	tkk + 'prolonged_sound_mark':		{'w':112, 'h':112, 's': 40, '': 'ー'},
	tkk + 'ideographic_period':			{'w':112, 'h':112, 's': 40, '': '。'},
	tkk + 'question_mark':				{'w':112, 'h':112, 's': 40, '': '？'},
	tkk + 'exclamation_mark':			{'w':112, 'h':112, 's': 40, '': '！'},
	tk + 'popup__voiced_mark':			{'w':112, 'h':112, 's': 40, '': '゛'},
	tk + 'popup__small':				{'w':112, 'h':112, 's': 24, '': '小'},
	tk + 'popup__semi_voiced_mark':		{'w':112, 'h':112, 's': 40, '': '゜'},
	qk + 'digit_one__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '1',   '',  '!',   '',   '']},
	qk + 'exclamation_mark__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '!',   '',   '',   '',  '1']},
	qk + 'digit_two__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '2',   '',  '"',   '',   '']},
	qk + 'quotation_mark__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '"',   '',   '',   '',  '2']},
	qk + 'digit_three__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '3',   '',  '#',   '',   '']},
	qk + 'number_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '#',   '',   '',   '',  '3']},
	qk + 'digit_four__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '4',   '',  '$',   '',   '']},
	qk + 'dollar_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '$',   '',   '',   '',  '4']},
	qk + 'digit_five__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '5',   '',  '%',   '',   '']},
	qk + 'percent_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '%',   '',   '',   '',  '5']},
	qk + 'digit_six__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '6',   '',  '&',   '',   '']},
	qk + 'ampersand__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '&',   '',   '',   '',  '6']},
	qk + 'digit_seven__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '7',   '',  "'",   '',   '']},
	qk + 'apostrophe__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ "'",   '',   '',   '',  '7']},
	qk + 'digit_eight__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '8',   '',  '(',   '',   '']},
	qk + 'left_parenthesis__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '(',   '',   '',   '',  '8']},
	qk + 'digit_nine__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '9',   '',  ')',   '',   '']},
	qk + 'right_parenthesis__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ ')',   '',   '',   '',  '9']},
	qk + 'hyphen_minus__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '-',   '',  '=',   '',   '']},
	qk + 'equals_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '=',   '',   '',   '',  '-']},
	qk + 'circumflex_accent__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '^',   '',  '~',   '',   '']},
	qk + 'tilde__icon':					{'w': 48, 'h': 74, 's': [32, 16], '': [ '~',   '',   '',   '',  '^']},
	qk + 'yen_sign__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['\\',   '',  '|',   '',   ''], 'f': fontface_z, 'n': qk + 'reverse_solidus'},
	qk + 'vertical_line__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '|',   '',   '',   '', '\\'], 'f': fontface_z},
	qk + 'commercial_at__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '@',   '',  '`',   '',   '']},
	qk + 'grave_accent__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '`',   '',   '',   '',  '@']},
	qk + 'left_square_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '[',   '',  '{',   '',   '']},
	qk + 'left_curly_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '{',   '',   '',   '',  '[']},
	qk + 'semicolon__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ ';',   '',  '+',   '',   '']},
	qk + 'plus_sign__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '+',   '',   '',   '',  ';']},
	qk + 'colon__icon':					{'w': 48, 'h': 74, 's': [32, 16], '': [ ':',   '',  '*',   '',   '']},
	qk + 'asterisk__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '*',   '',   '',   '',  ':']},
	qk + 'right_square_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': [ ']',   '',  '}',   '',   '']},
	qk + 'right_curly_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '}',   '',   '',   '',  ']']},
	qk + 'comma__icon':					{'w': 48, 'h': 74, 's': [32, 16], '': [ ',',   '',  '<',   '',   '']},
	qk + 'less_than_sign__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '<',   '',   '',   '',  ',']},
	qk + 'full_stop__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '.',   '',  '>',   '',   '']},
	qk + 'greater_than_sign__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '>',   '',   '',   '',  '.']},
	qk + 'solidus__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '/',   '',  '?',   '',   '']},
	qk + 'question_mark__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '?',   '',   '',   '',  '/']},
	qk + 'reverse_solidus__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['\\',   '',  '_',   '',   '']},
	qk + 'low_line__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '_',   '',   '',   '', '\\']},
	qk + 'digit_zero__icon2':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '0',   '',  '|',   '',   '']},
	qk + 'vertical_line__icon2':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '|',   '',   '',   '',  '0']},
	qks + 'q__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'q',  '1',   '',  '!',   '']},
	qkc + 'q__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'Q',  '1',   '',  '!',   '']},
	qks + 'w__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'w',  '2',   '',  '"',   '']},
	qkc + 'w__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'W',  '2',   '',  '"',   '']},
	qks + 'e__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'e',  '3',   '',  '#',   '']},
	qkc + 'e__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'E',  '3',   '',  '#',   '']},
	qks + 'r__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'r',  '4',   '',  '$',   '']},
	qkc + 'r__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'R',  '4',   '',  '$',   '']},
	qks + 't__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 't',  '5',   '',  '%',   '']},
	qkc + 't__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'T',  '5',   '',  '%',   '']},
	qks + 'y__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'y',  '6',   '',  '&',   '']},
	qkc + 'y__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'Y',  '6',   '',  '&',   '']},
	qks + 'u__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'u',  '7',   '',  "'",   '']},
	qkc + 'u__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'U',  '7',   '',  "'",   '']},
	qks + 'i__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'i',  '8',   '',  '(',   '']},
	qkc + 'i__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'I',  '8',   '',  '(',   '']},
	qks + 'o__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'o',  '9',   '',  ')',   '']},
	qkc + 'o__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'O',  '9',   '',  ')',   '']},
	qks + 'p__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'p',  '0',   '',  '|',   '']},
	qkc + 'p__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'P',  '0',   '',  '|',   '']},
	qks + 'k__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'k',  '-',   '',  '=',   '']},
	qkc + 'k__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'K',  '-',   '',  '=',   '']},
	qks + 'l__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'l',  '@',   '',  '`',   '']},
	qkc + 'l__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'L',  '@',   '',  '`',   '']},
	qks + 'm__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'm',  '^',   '',  '~',   '']},
	qkc + 'm__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'M',  '^',   '',  '~',   '']},
	qk + 'commercial_at__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '@',  '-',  '`',  '=',   '']},
	qk + 'grave_accent__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '`',  '-',   '',  '=',  '@']},
	qk + 'left_square_bracket__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '[',  '^',  '{',  '~',   '']},
	qk + 'left_curly_bracket__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '{',  '^',   '',  '~',  '[']},
	qk + 'semicolon__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': [ ';',  ':',  '+',  '*',   '']},
	qk + 'plus_sign__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '+',  ':',   '',  '*',  ';']},
	qk + 'comma__icon4':				{'w': 48, 'h': 74, 's': [32, 16], '': [ ',',  '[',  '<',  '{',   '']},
	qk + 'less_than_sign__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '<',  '[',   '',  '{',  ',']},
	qk + 'full_stop__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '.',  ']',  '>',  '}',   '']},
	qk + 'greater_than_sign__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '>',  ']',   '',  '}',  '.']},
	qk + 'solidus__icon4':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '/', '\\',  '?',  '_',   '']},
	qk + 'question_mark__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '?', '\\',   '',  '_',  '/']},
	qks + 'q__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'q',  '1',   '',  '!',  '1']},
	qkc + 'q__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'Q',  '1',  '1',  '!',   '']},
	qks + 'p__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'p',  '0',   '',  '|',  '|']},
	qkc + 'p__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'P',  '0',  '|',  '|',   '']},
	qk + 'commercial_at__icon5':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '@',  '-',  '`',  '=',  '=']},
	qk + 'grave_accent__icon5':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '`',  '-',  '=',  '=',  '@']},
	qk + 'semicolon__icon5':			{'w': 48, 'h': 74, 's': [32, 16], '': [ ';',  ':',  '+',  '*',  '*']},
	qk + 'plus_sign__icon5':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '+',  ':',  '*',  '*',  ';']},
	qk + 'solidus__icon5':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '/', '\\',  '?',  '_',  '_']},
	qk + 'question_mark__icon5':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '?', '\\',  '_',  '_',  '/']},
	qk + 'digit_one__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '1',  '',   '!',  '2',  '"']},
	qk + 'digit_two__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '2',  '1',  '"',   '',  '!']},
	qk + 'digit_three__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '3',   '',  '#',  '4',  '$']},
	qk + 'digit_four__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '4',  '3',  '$',   '',  '#']},
	qk + 'digit_five__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '5',   '',  '%',  '6',  '&']},
	qk + 'digit_six__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '6',  '5',  '&',   '',  '%']},
	qk + 'digit_seven__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '7',   '',  "'",  '8',  '(']},
	qk + 'digit_eight__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '8',  '7',  '(',   '',  "'"]},
	qk + 'digit_nine__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '9',   '',  ')',  '0',  '|']},
	qk + 'digit_zero__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '0',  '9',  '|',   '',  ')']},
	qk + 'hyphen_minus__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '-',   '',  '=',  '^',  '~']},
	qk + 'circumflex_accent__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '^',  '-',  '~',   '',  '=']},
	qks + 'q__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'q',   '',  'Q',  'w',  'W']},
	qks + 'w__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'w',  'q',  'W',   '',  'Q']},
	qks + 'e__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'e',   '',  'E',  'r',  'R']},
	qks + 'r__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'r',  'e',  'R',   '',  'E']},
	qks + 't__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 't',   '',  'T',  'y',  'Y']},
	qks + 'y__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'y',  't',  'Y',   '',  'T']},
	qks + 'u__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'u',   '',  'U',  'i',  'I']},
	qks + 'i__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'i',  'u',  'I',   '',  'U']},
	qks + 'o__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'o',   '',  'O',  'p',  'P']},
	qks + 'p__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'p',  'o',  'P',   '',  'O']},
	qk + 'commercial_at__icon1':		{'w': 48, 'h': 74, 's': [32, 16], '': [ '@',   '',  '`',  '[',  '{']},
	qk + 'left_square_bracket__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': [ '[',  '@',  '{',   '',  '`']},
	qks + 'a__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'a',   '',  'A',  's',  'S']},
	qks + 's__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 's',  'a',  'S',   '',  'A']},
	qks + 'd__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'd',   '',  'D',  'f',  'F']},
	qks + 'f__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'f',  'd',  'F',   '',  'D']},
	qks + 'g__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'g',   '',  'G',  'h',  'H']},
	qks + 'h__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'h',  'g',  'H',   '',  'G']},
	qks + 'j__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'j',   '',  'J',  'k',  'K']},
	qks + 'k__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'k',  'j',  'K',   '',  'J']},
	qks + 'l__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'l',   '',  'L',  ';',  '+']},
	qk + 'semicolon__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ ';',  'l',  '+',   '',  'L']},
	qk + 'colon__icon1':				{'w': 48, 'h': 74, 's': [32, 16], '': [ ':',   '',  '*',  ']',  '}']},
	qk + 'right_square_bracket__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': [ ']',  ':',  '}',   '',  '*']},
	qks + 'z__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'z',   '',  'Z',  'x',  'X']},
	qks + 'x__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'x',  'z',  'X',   '',  'Z']},
	qks + 'c__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'c',   '',  'C',  'v',  'V']},
	qks + 'v__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'v',  'c',  'V',   '',  'C']},
	qks + 'b__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'b',   '',  'B',  'n',  'N']},
	qks + 'n__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'n',  'b',  'N',   '',  'B']},
	qks + 'm__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': [ 'm',   '',  'M',  ',',  '<']},
	qk + 'comma__icon1':				{'w': 48, 'h': 74, 's': [32, 16], '': [ ',',  'm',  '<',   '',  'M']},
	qk + 'full_stop__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': [ '.',   '',  '>',  '/',  '?']},
	qk + 'solidus__icon1':				{'w': 48, 'h': 74, 's': [32, 16], '': [ '/',  '.',  '?',   '',  '>']},
	qf + 'comma':						{'w': 48, 'h': 74, 's': 32, '':  ','},
	qf + 'full_stop':					{'w': 48, 'h': 74, 's': 32, '':  '.'},
	qk + 'digit_one':					{'w': 48, 'h': 74, 's': 32, '':  '1'},
	qk + 'digit_two':					{'w': 48, 'h': 74, 's': 32, '':  '2'},
	qk + 'digit_three':					{'w': 48, 'h': 74, 's': 32, '':  '3'},
	qk + 'digit_four':					{'w': 48, 'h': 74, 's': 32, '':  '4'},
	qk + 'digit_five':					{'w': 48, 'h': 74, 's': 32, '':  '5'},
	qk + 'digit_six':					{'w': 48, 'h': 74, 's': 32, '':  '6'},
	qk + 'digit_seven':					{'w': 48, 'h': 74, 's': 32, '':  '7'},
	qk + 'digit_eight':					{'w': 48, 'h': 74, 's': 32, '':  '8'},
	qk + 'digit_nine':					{'w': 48, 'h': 74, 's': 32, '':  '9'},
	qk + 'digit_zero':					{'w': 48, 'h': 74, 's': 32, '':  '0'},
	qkc + 'a':							{'w': 48, 'h': 74, 's': 32, '':  'A'},
	qkc + 'b':							{'w': 48, 'h': 74, 's': 32, '':  'B'},
	qkc + 'c':							{'w': 48, 'h': 74, 's': 32, '':  'C'},
	qkc + 'd':							{'w': 48, 'h': 74, 's': 32, '':  'D'},
	qkc + 'e':							{'w': 48, 'h': 74, 's': 32, '':  'E'},
	qkc + 'f':							{'w': 48, 'h': 74, 's': 32, '':  'F'},
	qkc + 'g':							{'w': 48, 'h': 74, 's': 32, '':  'G'},
	qkc + 'h':							{'w': 48, 'h': 74, 's': 32, '':  'H'},
	qkc + 'i':							{'w': 48, 'h': 74, 's': 32, '':  'I'},
	qkc + 'j':							{'w': 48, 'h': 74, 's': 32, '':  'J'},
	qkc + 'k':							{'w': 48, 'h': 74, 's': 32, '':  'K'},
	qkc + 'l':							{'w': 48, 'h': 74, 's': 32, '':  'L'},
	qkc + 'm':							{'w': 48, 'h': 74, 's': 32, '':  'M'},
	qkc + 'n':							{'w': 48, 'h': 74, 's': 32, '':  'N'},
	qkc + 'o':							{'w': 48, 'h': 74, 's': 32, '':  'O'},
	qkc + 'p':							{'w': 48, 'h': 74, 's': 32, '':  'P'},
	qkc + 'q':							{'w': 48, 'h': 74, 's': 32, '':  'Q'},
	qkc + 'r':							{'w': 48, 'h': 74, 's': 32, '':  'R'},
	qkc + 's':							{'w': 48, 'h': 74, 's': 32, '':  'S'},
	qkc + 't':							{'w': 48, 'h': 74, 's': 32, '':  'T'},
	qkc + 'u':							{'w': 48, 'h': 74, 's': 32, '':  'U'},
	qkc + 'v':							{'w': 48, 'h': 74, 's': 32, '':  'V'},
	qkc + 'w':							{'w': 48, 'h': 74, 's': 32, '':  'W'},
	qkc + 'x':							{'w': 48, 'h': 74, 's': 32, '':  'X'},
	qkc + 'y':							{'w': 48, 'h': 74, 's': 32, '':  'Y'},
	qkc + 'z':							{'w': 48, 'h': 74, 's': 32, '':  'Z'},
	qks + 'a':							{'w': 48, 'h': 74, 's': 32, '':  'a'},
	qks + 'b':							{'w': 48, 'h': 74, 's': 32, '':  'b'},
	qks + 'c':							{'w': 48, 'h': 74, 's': 32, '':  'c'},
	qks + 'd':							{'w': 48, 'h': 74, 's': 32, '':  'd'},
	qks + 'e':							{'w': 48, 'h': 74, 's': 32, '':  'e'},
	qks + 'f':							{'w': 48, 'h': 74, 's': 32, '':  'f'},
	qks + 'g':							{'w': 48, 'h': 74, 's': 32, '':  'g'},
	qks + 'h':							{'w': 48, 'h': 74, 's': 32, '':  'h'},
	qks + 'i':							{'w': 48, 'h': 74, 's': 32, '':  'i'},
	qks + 'j':							{'w': 48, 'h': 74, 's': 32, '':  'j'},
	qks + 'k':							{'w': 48, 'h': 74, 's': 32, '':  'k'},
	qks + 'l':							{'w': 48, 'h': 74, 's': 32, '':  'l'},
	qks + 'm':							{'w': 48, 'h': 74, 's': 32, '':  'm'},
	qks + 'n':							{'w': 48, 'h': 74, 's': 32, '':  'n'},
	qks + 'o':							{'w': 48, 'h': 74, 's': 32, '':  'o'},
	qks + 'p':							{'w': 48, 'h': 74, 's': 32, '':  'p'},
	qks + 'q':							{'w': 48, 'h': 74, 's': 32, '':  'q'},
	qks + 'r':							{'w': 48, 'h': 74, 's': 32, '':  'r'},
	qks + 's':							{'w': 48, 'h': 74, 's': 32, '':  's'},
	qks + 't':							{'w': 48, 'h': 74, 's': 32, '':  't'},
	qks + 'u':							{'w': 48, 'h': 74, 's': 32, '':  'u'},
	qks + 'v':							{'w': 48, 'h': 74, 's': 32, '':  'v'},
	qks + 'w':							{'w': 48, 'h': 74, 's': 32, '':  'w'},
	qks + 'x':							{'w': 48, 'h': 74, 's': 32, '':  'x'},
	qks + 'y':							{'w': 48, 'h': 74, 's': 32, '':  'y'},
	qks + 'z':							{'w': 48, 'h': 74, 's': 32, '':  'z'},
	qk + 'exclamation_mark':			{'w': 48, 'h': 74, 's': 32, '':  '!'},
	qk + 'quotation_mark':				{'w': 48, 'h': 74, 's': 32, '':  '"'},
	qk + 'number_sign':					{'w': 48, 'h': 74, 's': 32, '':  '#'},
	qk + 'dollar_sign':					{'w': 48, 'h': 74, 's': 32, '':  '$'},
	qk + 'percent_sign':				{'w': 48, 'h': 74, 's': 32, '':  '%'},
	qk + 'ampersand':					{'w': 48, 'h': 74, 's': 32, '':  '&'},
	qk + 'apostrophe':					{'w': 48, 'h': 74, 's': 32, '':  "'"},
	qk + 'left_parenthesis':			{'w': 48, 'h': 74, 's': 32, '':  '('},
	qk + 'right_parenthesis':			{'w': 48, 'h': 74, 's': 32, '':  ')'},
	qk + 'hyphen_minus':				{'w': 48, 'h': 74, 's': 32, '':  '-'},
	qk + 'equals_sign':					{'w': 48, 'h': 74, 's': 32, '':  '='},
	qk + 'circumflex_accent':			{'w': 48, 'h': 74, 's': 32, '':  '^'},
	qk + 'tilde':						{'w': 48, 'h': 74, 's': 32, '':  '~'},
	qk + 'vertical_line':				{'w': 48, 'h': 74, 's': 32, '':  '|'},
	qk + 'yen_sign':					{'w': 48, 'h': 74, 's': 32, '': '\\', 'f': fontface_z, 'n': qk + 'reverse_solidus'},
	qk + 'commercial_at':				{'w': 48, 'h': 74, 's': 32, '':  '@'},
	qk + 'grave_accent':				{'w': 48, 'h': 74, 's': 32, '':  '`'},
	qk + 'left_square_bracket':			{'w': 48, 'h': 74, 's': 32, '':  '['},
	qk + 'left_curly_bracket':			{'w': 48, 'h': 74, 's': 32, '':  '{'},
	qk + 'semicolon':					{'w': 48, 'h': 74, 's': 32, '':  ';'},
	qk + 'plus_sign':					{'w': 48, 'h': 74, 's': 32, '':  '+'},
	qk + 'colon':						{'w': 48, 'h': 74, 's': 32, '':  ':'},
	qk + 'asterisk':					{'w': 48, 'h': 74, 's': 32, '':  '*'},
	qk + 'right_square_bracket':		{'w': 48, 'h': 74, 's': 32, '':  ']'},
	qk + 'right_curly_bracket':			{'w': 48, 'h': 74, 's': 32, '':  '}'},
	qk + 'comma':						{'w': 48, 'h': 74, 's': 32, '':  ','},
	qk + 'less_than_sign':				{'w': 48, 'h': 74, 's': 32, '':  '<'},
	qk + 'full_stop':					{'w': 48, 'h': 74, 's': 32, '':  '.'},
	qk + 'greater_than_sign':			{'w': 48, 'h': 74, 's': 32, '':  '>'},
	qk + 'solidus':						{'w': 48, 'h': 74, 's': 32, '':  '/'},
	qk + 'question_mark':				{'w': 48, 'h': 74, 's': 32, '':  '?'},
	qk + 'reverse_solidus':				{'w': 48, 'h': 74, 's': 32, '': '\\'},
	qk + 'low_line':					{'w': 48, 'h': 74, 's': 32, '':  '_'},
	qkf + 'digit_one__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['１',   '', '！',   '',   '']},
	qkf + 'exclamation_mark__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['！',   '',   '',   '', '１']},
	qkf + 'digit_two__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['２',   '', '”',   '',   '']},
	qkf + 'quotation_mark__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['”',   '',   '',   '', '２']},
	qkf + 'digit_three__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['３',   '', '＃',   '',   '']},
	qkf + 'number_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＃',   '',   '',   '', '３']},
	qkf + 'digit_four__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['４',   '', '＄',   '',   '']},
	qkf + 'dollar_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＄',   '',   '',   '', '４']},
	qkf + 'digit_five__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['５',   '', '％',   '',   '']},
	qkf + 'percent_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['％',   '',   '',   '', '５']},
	qkf + 'digit_six__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['６',   '', '＆',   '',   '']},
	qkf + 'ampersand__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＆',   '',   '',   '', '６']},
	qkf + 'digit_seven__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['７',   '', '’',   '',   '']},
	qkf + 'apostrophe__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['’',   '',   '',   '', '７']},
	qkf + 'digit_eight__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['８',   '', '（',   '',   '']},
	qkf + 'left_parenthesis__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['（',   '',   '',   '', '８']},
	qkf + 'digit_nine__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['９',   '', '）',   '',   '']},
	qkf + 'right_parenthesis__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['）',   '',   '',   '', '９']},
	qk + 'prolonged_sound_mark__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['－',   '', '＝',   '',   ''], 'n': qk + 'minus_sign'},
	qkf + 'equals_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＝',   '',   '',   '', 'ー']},
	qkf + 'circumflex_accent__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['＾',   '', '～',   '',   '']},
	qkf + 'tilde__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['～',   '',   '',   '', '＾']},
	qkf + 'yen_sign__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['￥',   '', '｜',   '',   ''], 'n': qk + 'reverse_solidus'},
	qkf + 'vertical_line__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['｜',   '',   '',   '', '￥']},
	qkf + 'commercial_at__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＠',   '', '｀',   '',   '']},
	qkf + 'grave_accent__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['｀',   '',   '',   '', '＠']},
	qk + 'left_corner_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['「',   '', '｛',   '',   '']},
	qkf + 'left_curly_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['｛',   '',   '',   '', '「']},
	qkf + 'semicolon__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['；',   '', '＋',   '',   '']},
	qkf + 'plus_sign__icon':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＋',   '',   '',   '', '；']},
	qkf + 'colon__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['：',   '', '＊',   '',   '']},
	qkf + 'asterisk__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['＊',   '',   '',   '', '：']},
	qk + 'right_corner_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['」',   '', '｝',   '',   '']},
	qkf + 'right_curly_bracket__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['｝',   '',   '',   '', '」']},
	qk + 'ideographic_comma__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['、',   '', '＜',   '',   '']},
	qkf + 'less_than_sign__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＜',   '',   '',   '', '、']},
	qk + 'ideographic_full_stop__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['。',   '', '＞',   '',   '']},
	qkf + 'greater_than_sign__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['＞',   '',   '',   '', '。']},
	qk + 'katakana_middle_dot__icon':	{'w': 48, 'h': 74, 's': [32, 16], '': ['・',   '', '？',   '',   '']},
	qkf + 'question_mark__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['？',   '',   '',   '', '・']},
	qkf + 'reverse_solidus__icon':		{'w': 48, 'h': 74, 's': [32, 16], '': ['￥',   '', '＿',   '',   '']},	# '＼'
	qkf + 'low_line__icon':				{'w': 48, 'h': 74, 's': [32, 16], '': ['＿',   '',   '',   '', '￥']},	# '＼'
	qkf + 'digit_zero__icon2':			{'w': 48, 'h': 74, 's': [32, 16], '': ['０',   '', '｜',   '',   '']},
	qkf + 'vertical_line__icon2':		{'w': 48, 'h': 74, 's': [32, 16], '': ['｜',   '',   '',   '', '０']},
	qkfs + 'q__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｑ', '１',   '', '！',   '']},
	qkfc + 'q__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｑ', '１',   '', '！',   '']},
	qkfs + 'w__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｗ', '２',   '', '”',   '']},
	qkfc + 'w__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｗ', '２',   '', '”',   '']},
	qkfs + 'e__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｅ', '３',   '', '＃',   '']},
	qkfc + 'e__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｅ', '３',   '', '＃',   '']},
	qkfs + 'r__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｒ', '４',   '', '＄',   '']},
	qkfc + 'r__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｒ', '４',   '', '＄',   '']},
	qkfs + 't__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｔ', '５',   '', '％',   '']},
	qkfc + 't__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｔ', '５',   '', '％',   '']},
	qkfs + 'y__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｙ', '６',   '', '＆',   '']},
	qkfc + 'y__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｙ', '６',   '', '＆',   '']},
	qkfs + 'u__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｕ', '７',   '', '’',   '']},
	qkfc + 'u__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｕ', '７',   '', '’',   '']},
	qkfs + 'i__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｉ', '８',   '', '（',   '']},
	qkfc + 'i__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｉ', '８',   '', '（',   '']},
	qkfs + 'o__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｏ', '９',   '', '）',   '']},
	qkfc + 'o__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｏ', '９',   '', '）',   '']},
	qkfs + 'p__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｐ', '０',   '', '｜',   '']},
	qkfc + 'p__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｐ', '０',   '', '｜',   '']},
	qkfs + 'k__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｋ', '－',   '', '＝',   '']},
	qkfc + 'k__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｋ', '－',   '', '＝',   '']},
	qkfs + 'l__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｌ', '＠',   '', '｀',   '']},
	qkfc + 'l__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｌ', '＠',   '', '｀',   '']},
	qkfs + 'm__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｍ', '＾',   '', '～',   '']},
	qkfc + 'm__icon4':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｍ', '＾',   '', '～',   '']},
	qkf + 'commercial_at__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＠', '－', '｀', '＝',   '']},
	qkf + 'grave_accent__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': ['｀', '－',   '', '＝', '＠']},
	qk + 'left_corner_bracket__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': ['「', '＾', '｛', '～',   '']},
	qkf + 'left_curly_bracket__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': ['｛', '＾',   '', '～', '「']},
	qkf + 'semicolon__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': ['；', '：', '＋', '＊',   '']},
	qkf + 'plus_sign__icon4':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＋', '：',   '', '＊', '；']},
	qk + 'ideographic_comma__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': ['、', '「', '＜', '｛',   '']},
	qkf + 'less_than_sign__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＜', '「',   '', '｛', '、']},
	qk + 'ideographic_full_stop__icon4':{'w': 48, 'h': 74, 's': [32, 16], '': ['。', '」', '＞', '｝',   '']},
	qkf + 'greater_than_sign__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': ['＞', '」',   '', '｝', '。']},
	qk + 'katakana_middle_dot__icon4':	{'w': 48, 'h': 74, 's': [32, 16], '': ['・', '￥', '？', '＿',   '']},	# '＼'
	qkf + 'question_mark__icon4':		{'w': 48, 'h': 74, 's': [32, 16], '': ['？', '￥',   '', '＿', '・']},	# '＼'
	qkfs + 'q__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｑ', '１',   '', '！', '１']},
	qkfc + 'q__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｑ', '１', '１', '！',   '']},
	qkfs + 'p__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｐ', '０',   '', '｜', '｜']},
	qkfc + 'p__icon5':					{'w': 48, 'h': 74, 's': [32, 16], '': ['Ｐ', '０', '｜', '｜',   '']},
	qkf + 'commercial_at__icon5':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＠', '－', '｀', '＝', '＝']},
	qkf + 'grave_accent__icon5':		{'w': 48, 'h': 74, 's': [32, 16], '': ['｀', '－', '＝', '＝', '＠']},
	qkf + 'semicolon__icon5':			{'w': 48, 'h': 74, 's': [32, 16], '': ['；', '：', '＋', '＊', '＊']},
	qkf + 'plus_sign__icon5':			{'w': 48, 'h': 74, 's': [32, 16], '': ['＋', '：', '＊', '＊', '；']},
	qk + 'katakana_middle_dot__icon5':	{'w': 48, 'h': 74, 's': [32, 16], '': ['・', '￥', '？', '＿', '＿']},	# '＼'
	qkf + 'question_mark__icon5':		{'w': 48, 'h': 74, 's': [32, 16], '': ['？', '￥', '＿', '＿', '・']},	# '＼'
	qkf + 'digit_one__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['１', '',   '！', '２', '”']},
	qkf + 'digit_two__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['２', '１', '”',   '', '！']},
	qkf + 'digit_three__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['３',   '', '＃', '４', '＄']},
	qkf + 'digit_four__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['４', '３', '＄',   '', '＃']},
	qkf + 'digit_five__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['５',   '', '％', '６', '＆']},
	qkf + 'digit_six__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['６', '５', '＆',   '', '％']},
	qkf + 'digit_seven__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['７',   '', '’', '８', '（']},
	qkf + 'digit_eight__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['８', '７', '（',   '', '’']},
	qkf + 'digit_nine__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['９',   '', '）', '０', '｜']},
	qkf + 'digit_zero__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['０', '９', '｜',   '', '）']},
	qk + 'prolonged_sound_mark__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['ー',   '', '＝', '＾', '～'], 'n': qk + 'minus_sign'},
	qkf + 'circumflex_accent__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['＾', 'ー', '～',   '', '＝']},
	qkfs + 'q__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｑ',   '', 'Ｑ', 'ｗ', 'Ｗ']},
	qkfs + 'w__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｗ', 'ｑ', 'Ｗ',   '', 'Ｑ']},
	qkfs + 'e__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｅ',   '', 'Ｅ', 'ｒ', 'Ｒ']},
	qkfs + 'r__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｒ', 'ｅ', 'Ｒ',   '', 'Ｅ']},
	qkfs + 't__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｔ',   '', 'Ｔ', 'ｙ', 'Ｙ']},
	qkfs + 'y__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｙ', 'ｔ', 'Ｙ',   '', 'Ｔ']},
	qkfs + 'u__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｕ',   '', 'Ｕ', 'ｉ', 'Ｉ']},
	qkfs + 'i__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｉ', 'ｕ', 'Ｉ',   '', 'Ｕ']},
	qkfs + 'o__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｏ',   '', 'Ｏ', 'ｐ', 'Ｐ']},
	qkfs + 'p__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｐ', 'ｏ', 'Ｐ',   '', 'Ｏ']},
	qkf + 'commercial_at__icon1':		{'w': 48, 'h': 74, 's': [32, 16], '': ['＠',   '', '｀', '「', '｛']},
	qk + 'left_corner_bracket__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['「', '＠', '｛',   '', '｀']},
	qkfs + 'a__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ａ',   '', 'Ａ', 'ｓ', 'Ｓ']},
	qkfs + 's__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｓ', 'ａ', 'Ｓ',   '', 'Ａ']},
	qkfs + 'd__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｄ',   '', 'Ｄ', 'ｆ', 'Ｆ']},
	qkfs + 'f__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｆ', 'ｄ', 'Ｆ',   '', 'Ｄ']},
	qkfs + 'g__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｇ',   '', 'Ｇ', 'ｈ', 'Ｈ']},
	qkfs + 'h__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｈ', 'ｇ', 'Ｈ',   '', 'Ｇ']},
	qkfs + 'j__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｊ',   '', 'Ｊ', 'ｋ', 'Ｋ']},
	qkfs + 'k__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｋ', 'ｊ', 'Ｋ',   '', 'Ｊ']},
	qkfs + 'l__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｌ',   '', 'Ｌ', '；', '＋']},
	qkf + 'semicolon__icon1':			{'w': 48, 'h': 74, 's': [32, 16], '': ['；', 'ｌ', '＋',   '', 'Ｌ']},
	qkf + 'colon__icon1':				{'w': 48, 'h': 74, 's': [32, 16], '': ['：',   '', '＊', '」', '｝']},
	qk + 'right_corner_bracket__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['」', '：', '｝',   '', '＊']},
	qkfs + 'z__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｚ',   '', 'Ｚ', 'ｘ', 'Ｘ']},
	qkfs + 'x__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｘ', 'ｚ', 'Ｘ',   '', 'Ｚ']},
	qkfs + 'c__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｃ',   '', 'Ｃ', 'ｖ', 'Ｖ']},
	qkfs + 'v__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｖ', 'ｃ', 'Ｖ',   '', 'Ｃ']},
	qkfs + 'b__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｂ',   '', 'Ｂ', 'ｎ', 'Ｎ']},
	qkfs + 'n__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｎ', 'ｂ', 'Ｎ',   '', 'Ｂ']},
	qkfs + 'm__icon1':					{'w': 48, 'h': 74, 's': [32, 16], '': ['ｍ',   '', 'Ｍ', '、', '＜']},
	qk + 'ideographic_comma__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['、', 'ｍ', '＜',   '', 'Ｍ']},
	qk + 'ideographic_full_stop__icon1':{'w': 48, 'h': 74, 's': [32, 16], '': ['。',   '', '＞', '・', '？']},
	qk + 'katakana_middle_dot__icon1':	{'w': 48, 'h': 74, 's': [32, 16], '': ['・', '。', '？',   '', '＞']},
	qf + 'ideographic_comma':			{'w': 48, 'h': 74, 's': 32, '': '、'},
	qf + 'ideographic_full_stop':		{'w': 48, 'h': 74, 's': 32, '': '。'},
	qkf + 'digit_one':					{'w': 48, 'h': 74, 's': 32, '': '１'},
	qkf + 'digit_two':					{'w': 48, 'h': 74, 's': 32, '': '２'},
	qkf + 'digit_three':				{'w': 48, 'h': 74, 's': 32, '': '３'},
	qkf + 'digit_four':					{'w': 48, 'h': 74, 's': 32, '': '４'},
	qkf + 'digit_five':					{'w': 48, 'h': 74, 's': 32, '': '５'},
	qkf + 'digit_six':					{'w': 48, 'h': 74, 's': 32, '': '６'},
	qkf + 'digit_seven':				{'w': 48, 'h': 74, 's': 32, '': '７'},
	qkf + 'digit_eight':				{'w': 48, 'h': 74, 's': 32, '': '８'},
	qkf + 'digit_nine':					{'w': 48, 'h': 74, 's': 32, '': '９'},
	qkf + 'digit_zero':					{'w': 48, 'h': 74, 's': 32, '': '０'},
	qkfc + 'a':							{'w': 48, 'h': 74, 's': 32, '': 'Ａ'},
	qkfc + 'b':							{'w': 48, 'h': 74, 's': 32, '': 'Ｂ'},
	qkfc + 'c':							{'w': 48, 'h': 74, 's': 32, '': 'Ｃ'},
	qkfc + 'd':							{'w': 48, 'h': 74, 's': 32, '': 'Ｄ'},
	qkfc + 'e':							{'w': 48, 'h': 74, 's': 32, '': 'Ｅ'},
	qkfc + 'f':							{'w': 48, 'h': 74, 's': 32, '': 'Ｆ'},
	qkfc + 'g':							{'w': 48, 'h': 74, 's': 32, '': 'Ｇ'},
	qkfc + 'h':							{'w': 48, 'h': 74, 's': 32, '': 'Ｈ'},
	qkfc + 'i':							{'w': 48, 'h': 74, 's': 32, '': 'Ｉ'},
	qkfc + 'j':							{'w': 48, 'h': 74, 's': 32, '': 'Ｊ'},
	qkfc + 'k':							{'w': 48, 'h': 74, 's': 32, '': 'Ｋ'},
	qkfc + 'l':							{'w': 48, 'h': 74, 's': 32, '': 'Ｌ'},
	qkfc + 'm':							{'w': 48, 'h': 74, 's': 32, '': 'Ｍ'},
	qkfc + 'n':							{'w': 48, 'h': 74, 's': 32, '': 'Ｎ'},
	qkfc + 'o':							{'w': 48, 'h': 74, 's': 32, '': 'Ｏ'},
	qkfc + 'p':							{'w': 48, 'h': 74, 's': 32, '': 'Ｐ'},
	qkfc + 'q':							{'w': 48, 'h': 74, 's': 32, '': 'Ｑ'},
	qkfc + 'r':							{'w': 48, 'h': 74, 's': 32, '': 'Ｒ'},
	qkfc + 's':							{'w': 48, 'h': 74, 's': 32, '': 'Ｓ'},
	qkfc + 't':							{'w': 48, 'h': 74, 's': 32, '': 'Ｔ'},
	qkfc + 'u':							{'w': 48, 'h': 74, 's': 32, '': 'Ｕ'},
	qkfc + 'v':							{'w': 48, 'h': 74, 's': 32, '': 'Ｖ'},
	qkfc + 'w':							{'w': 48, 'h': 74, 's': 32, '': 'Ｗ'},
	qkfc + 'x':							{'w': 48, 'h': 74, 's': 32, '': 'Ｘ'},
	qkfc + 'y':							{'w': 48, 'h': 74, 's': 32, '': 'Ｙ'},
	qkfc + 'z':							{'w': 48, 'h': 74, 's': 32, '': 'Ｚ'},
	qkfs + 'a':							{'w': 48, 'h': 74, 's': 32, '': 'ａ'},
	qkfs + 'b':							{'w': 48, 'h': 74, 's': 32, '': 'ｂ'},
	qkfs + 'c':							{'w': 48, 'h': 74, 's': 32, '': 'ｃ'},
	qkfs + 'd':							{'w': 48, 'h': 74, 's': 32, '': 'ｄ'},
	qkfs + 'e':							{'w': 48, 'h': 74, 's': 32, '': 'ｅ'},
	qkfs + 'f':							{'w': 48, 'h': 74, 's': 32, '': 'ｆ'},
	qkfs + 'g':							{'w': 48, 'h': 74, 's': 32, '': 'ｇ'},
	qkfs + 'h':							{'w': 48, 'h': 74, 's': 32, '': 'ｈ'},
	qkfs + 'i':							{'w': 48, 'h': 74, 's': 32, '': 'ｉ'},
	qkfs + 'j':							{'w': 48, 'h': 74, 's': 32, '': 'ｊ'},
	qkfs + 'k':							{'w': 48, 'h': 74, 's': 32, '': 'ｋ'},
	qkfs + 'l':							{'w': 48, 'h': 74, 's': 32, '': 'ｌ'},
	qkfs + 'm':							{'w': 48, 'h': 74, 's': 32, '': 'ｍ'},
	qkfs + 'n':							{'w': 48, 'h': 74, 's': 32, '': 'ｎ'},
	qkfs + 'o':							{'w': 48, 'h': 74, 's': 32, '': 'ｏ'},
	qkfs + 'p':							{'w': 48, 'h': 74, 's': 32, '': 'ｐ'},
	qkfs + 'q':							{'w': 48, 'h': 74, 's': 32, '': 'ｑ'},
	qkfs + 'r':							{'w': 48, 'h': 74, 's': 32, '': 'ｒ'},
	qkfs + 's':							{'w': 48, 'h': 74, 's': 32, '': 'ｓ'},
	qkfs + 't':							{'w': 48, 'h': 74, 's': 32, '': 'ｔ'},
	qkfs + 'u':							{'w': 48, 'h': 74, 's': 32, '': 'ｕ'},
	qkfs + 'v':							{'w': 48, 'h': 74, 's': 32, '': 'ｖ'},
	qkfs + 'w':							{'w': 48, 'h': 74, 's': 32, '': 'ｗ'},
	qkfs + 'x':							{'w': 48, 'h': 74, 's': 32, '': 'ｘ'},
	qkfs + 'y':							{'w': 48, 'h': 74, 's': 32, '': 'ｙ'},
	qkfs + 'z':							{'w': 48, 'h': 74, 's': 32, '': 'ｚ'},
	qkf + 'exclamation_mark':			{'w': 48, 'h': 74, 's': 32, '': '！'},
	qkf + 'quotation_mark':				{'w': 48, 'h': 74, 's': 32, '': '”'},
	qkf + 'number_sign':				{'w': 48, 'h': 74, 's': 32, '': '＃'},
	qkf + 'dollar_sign':				{'w': 48, 'h': 74, 's': 32, '': '＄'},
	qkf + 'percent_sign':				{'w': 48, 'h': 74, 's': 32, '': '％'},
	qkf + 'ampersand':					{'w': 48, 'h': 74, 's': 32, '': '＆'},
	qkf + 'apostrophe':					{'w': 48, 'h': 74, 's': 32, '': '’'},
	qkf + 'left_parenthesis':			{'w': 48, 'h': 74, 's': 32, '': '（'},
	qkf + 'right_parenthesis':			{'w': 48, 'h': 74, 's': 32, '': '）'},
	qk + 'minus_sign':					{'w': 48, 'h': 74, 's': 32, '': '－'},
	qk + 'prolonged_sound_mark':		{'w': 48, 'h': 74, 's': 32, '': 'ー', 'n': qk + 'minus_sign'},
	qkf + 'equals_sign':				{'w': 48, 'h': 74, 's': 32, '': '＝'},
	qkf + 'circumflex_accent':			{'w': 48, 'h': 74, 's': 32, '': '＾'},
	qkf + 'tilde':						{'w': 48, 'h': 74, 's': 32, '': '～'},
	qk + 'wave_dash':					{'w': 48, 'h': 74, 's': 32, '': '～'},
	qkf + 'vertical_line':				{'w': 48, 'h': 74, 's': 32, '': '｜'},
	qkf + 'yen_sign':					{'w': 48, 'h': 74, 's': 32, '': '￥', 'n': qk + 'reverse_solidus'},
	qkf + 'commercial_at':				{'w': 48, 'h': 74, 's': 32, '': '＠'},
	qkf + 'grave_accent':				{'w': 48, 'h': 74, 's': 32, '': '｀'},
	qk + 'left_corner_bracket':			{'w': 48, 'h': 74, 's': 32, '': '「'},
	qkf + 'left_curly_bracket':			{'w': 48, 'h': 74, 's': 32, '': '｛'},
	qkf + 'semicolon':					{'w': 48, 'h': 74, 's': 32, '': '；'},
	qkf + 'plus_sign':					{'w': 48, 'h': 74, 's': 32, '': '＋'},
	qkf + 'colon':						{'w': 48, 'h': 74, 's': 32, '': '：'},
	qkf + 'asterisk':					{'w': 48, 'h': 74, 's': 32, '': '＊'},
	qk + 'right_corner_bracket':		{'w': 48, 'h': 74, 's': 32, '': '」'},
	qkf + 'right_curly_bracket':		{'w': 48, 'h': 74, 's': 32, '': '｝'},
	qk + 'ideographic_comma':			{'w': 48, 'h': 74, 's': 32, '': '、'},
	qkf + 'less_than_sign':				{'w': 48, 'h': 74, 's': 32, '': '＜'},
	qk + 'ideographic_full_stop':		{'w': 48, 'h': 74, 's': 32, '': '。'},
	qkf + 'greater_than_sign':			{'w': 48, 'h': 74, 's': 32, '': '＞'},
	qkf + 'solidus':					{'w': 48, 'h': 74, 's': 32, '': '／'},
	qk + 'katakana_middle_dot':			{'w': 48, 'h': 74, 's': 32, '': '・'},
	qkf + 'question_mark':				{'w': 48, 'h': 74, 's': 32, '': '？'},
	qkf + 'reverse_solidus':			{'w': 48, 'h': 74, 's': 32, '': '￥'},	# '＼'
	qkf + 'low_line':					{'w': 48, 'h': 74, 's': 32, '': '＿'},
	qk + 'multiplication_sign':			{'w': 48, 'h': 74, 's': 32, '': '×'},
	qk + 'division_sign':				{'w': 48, 'h': 74, 's': 32, '': '÷'},
	qk + 'reference_mark':				{'w': 48, 'h': 74, 's': 32, '': '※'},
	qk + 'two_dot_leader':				{'w': 48, 'h': 74, 's': 32, '': '¨'},
	qk + 'horizontal_ellipsis':			{'w': 48, 'h': 74, 's': 32, '': '…'},
	qk+'left_black_lenticular_bracket':	{'w': 48, 'h': 74, 's': 32, '': '【'},
	qk+'right_black_lenticular_bracket':{'w': 48, 'h': 74, 's': 32, '': '】'},
	qk + 'postal_mark':					{'w': 48, 'h': 74, 's': 32, '': '〒'},
	qk + 'eighth_note':					{'w': 48, 'h': 74, 's': 32, '': '♪'},
	qk + 'black_star':					{'w': 48, 'h': 74, 's': 32, '': '★'},
	qk + 'black_heart_suit':			{'w': 48, 'h': 74, 's': 32, '': '♥', 'f': fontface_h},
	qk + 'cjk_day':						{'w': 48, 'h': 74, 's': 32, '': '日'},
	qk + 'cjk_hour':					{'w': 48, 'h': 74, 's': 32, '': '時'},
	qk + 'cjk_minute':					{'w': 48, 'h': 74, 's': 32, '': '分'},
	qk + 'cjk_month':					{'w': 48, 'h': 74, 's': 32, '': '月'},
	qk + 'parenthesized_friday':		{'w': 48, 'h': 74, 's': 28, '': '(金)'},
	qk + 'parenthesized_monday':		{'w': 48, 'h': 74, 's': 28, '': '(月)'},
	qk + 'parenthesized_saturday':		{'w': 48, 'h': 74, 's': 28, '': '(土)'},
	qk + 'parenthesized_sunday':		{'w': 48, 'h': 74, 's': 28, '': '(日)'},
	qk + 'parenthesized_thursday':		{'w': 48, 'h': 74, 's': 28, '': '(木)'},
	qk + 'parenthesized_tuesday':		{'w': 48, 'h': 74, 's': 28, '': '(火)'},
	qk + 'parenthesized_wednesday':		{'w': 48, 'h': 74, 's': 28, '': '(水)'},
}.iteritems()):
#	if not os.path.isfile(root1 + svgdir + name): continue
	path = root1 + svgdir + (params['n'] if 'n' in params else name) + '.svg'
	if not os.path.isfile(path): path = re.sub(r'__icon[1245]\.svg', '__icon.svg', path)
	if not os.path.isfile(path): path = re.sub(r'__icon\.svg', '.svg', path)
	if not os.path.isfile(path): path = re.sub(r'__popup[1245]\.svg', '__popup.svg', path)
	if not os.path.isfile(path): path = path.replace('__fullwidth_', '__')
	svg = load(path)
	if not svg: print path
	w = params['w']
	h = params['h']
	s = params['s'] if isinstance(params['s'], list) else [params['s'], params['s']]
	if 'n' in params and params['n'] in [qf + 'text_kana__icon', qf + 'text_kana__popup']:
		svg = svg.replace('width="70px"',  'width="'  + str(w) + 'px"')
		svg = svg.replace('height="74px"', 'height="' + str(h) + 'px"')
		svg = svg.replace('0 0 70 74', '0 0 ' + str(w) + ' ' + str(h))
	id = 'style-keyicon-popup-function' if 'popup' in name else 'style-keyicon-function'
	svg = svg.replace('id=""', 'id="' + id + '"')
	texts = params['']
	if texts != '':
		if not re.search('<path ', svg): svg = svg.replace('</svg>', '<g id="' + id + '">\n\t<path style="fill:#DDDDDD;" d=""/>\n</g>\n</svg>')
		surface = cairo.SVGSurface(root2 + workdir + name + '.svg', w, h)
		context = cairo.Context(surface)
		m = re.findall(r'	<path style="fill:#(\w\w)(\w\w)(\w\w);" d=""\s*/>', svg)
		if len(m) == 0: m = [('27', '27', '27')]
		context.set_source_rgb(int(m[0][0], 16) / 0xff, int(m[0][1], 16) / 0xff, int(m[0][2], 16) / 0xff)
		for index, text in enumerate(texts if isinstance(texts, list) else [texts]):
			q = (w == 48 and h == 74 and index)
			context.select_font_face(params['f'] if 'f' in params else fontface_z if re.search(r'[^\x20-\x7e]', text) or 'b' in params else fontface_h, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_NORMAL)
			context.set_font_size(12 if 'b' in params and text in ['ヶ', 'っ', 'ゃゅょ'] else s[0 if not index else 1])
			(x_bearing, y_bearing, width, height, x_advance, y_advance) = context.text_extents(text)
			x = w / 2 + (0 if not q or index in [1, 3] else -8 if index == 2 else +8)
			y = h / 2 + (params['y'] if 'y' in params else 0 if not q or index in [2, 4] else +8 if index == 1 else -8)
			o = ((s[0] + s[1]) / 2) + (-6 if q else 4 if w == 112 and h == 112 else 2 if '__function__' in name or '__space__' in name else 0)
			if 'b' in params:
				ox = [-o / 2, -o, o, o, o]
				oy = [-o / 2, 0, -o, 0, o]
			elif 'c' not in params:
				ox = [0, -o, 0, o, 0]
				oy = [0, 0, -o, 0, o]
			elif params['c'] == 0:
				ox = [0, -o, o, 0]
				oy = [-o, 0, 0, o]
			elif params['c'] == 1:
				ox = [0, o, -o, 0]
				oy = [-o, 0, 0, o]
			elif params['c'] == 2:
				ox = [0, 0, -o, o]
				oy = [-o, o, 0, 0]
			elif params['c'] == -3:
				ox = [-o, 0, o]
				oy = [0, 0, 0]
			else:
				ox = [-o / 2, o / 2]
				oy = [0, 0]
			if 'b' in params and index in [2, 3]: x += 14 - width / 2;
			context.move_to(x + ox[index] - width / 2 - x_bearing, y + oy[index] - height / 2 - y_bearing)
			context.text_path(text)
			if 'c' in params and (params['c'] < 0 or index == 1): context.fill()
		context.fill()
		surface.write_to_png(root2 + workdir + name + '.png')
		context.show_page()
		surface.finish()
		m1 = re.findall(r'<path[^<>]+( d="[^"]+")/>', load(root2 + workdir + name + '.svg'))
#		if len(m1) != (params['c'] if 'c' in params else 1): print '%d %s' % (len(m1), name)
		count = 0
		def countup(m2):
			global count
			d = m1[count]
			count += 1
			return m2.group(1) + d + m2.group(2)
		svg = re.sub(r'(<path(?: style="fill:#\w+;")?) d=""\s*(/>)', countup, svg, len(m1))
	if 'k' in params:
		svg = svg.replace('fill:#DDDDDD;', 'fill:#272727;')
		svg = re.sub(' id="style-keyicon(-popup)?-function[^"]*"', '', svg)
	save(root2 + svgdir + name + '.svg', svg)
	save(root3 + svgdir + name + '.svg', svg)
